*:********************************************************************
*:
*: Procedure file :frxobj.prg
*:
*: Contents :
*: 
*: 		Class     QuickReport AS Custom
*: 
*: 		Class     TitleBandClass AS Band
*: 
*: 		Class     PageHeaderBandClass AS Band
*: 
*: 		Class     PageFooterBandClass AS Band
*: 
*: 		Class     DetailBandClass AS Band
*: 
*: 		Class     SummaryBandClass AS Band
*: 
*: 		Class     Band AS Control
*: 
*: 		Class     QuickReportForm AS Form
*:
*: (c) Piva, BEAR v.43 on 29.04.2003 11:44
*:********************************************************************
*
* Create self Quick Report
*
*  Pirozhkoff V. 2001
* e-mail: piva@kurgan.isp.ru
*
* PUBLIC DOMAIN
*
#include frx.h
#define CR		Chr(13)

*:********************************************************************
*:
*:    Class : QuickReport based on Custom
*:
*:********************************************************************
Define Class QuickReport As Custom
	Title=""
	ReportName=Sys(2015)	&& Report Name
	ReportFile=""			&& Report DBF File (such as REPORT.FRX)
	ReportMemo=""			&& Report FPT File (such as REPORT.FRT)
	ReportSource=""			&& Report Primary source table/cursor
	
	Tmpfile=.T.				&& Internal use - Set .T. if reportname generated by object
	
	PrinterName=Set("PRINTER",3)	&& Default FoxPro Printer
	Copies=1				&& print copies
	Orientation=PAGE_AUTOMATIC	&& 0 - Portrait , 1 - Landscape, 2 - By Quick Report Decide
	
	*** REPORT command parameters
	
	For=""					&& For Expression
	While=""				&& While Expression
	From=1					&& Print range FROM page number
	To=9999					&& TO range page number
	
	Top=0					&& For internnal use ( calcultaing top position of bands )
	Height=0				&&
	Width=0					&& For internal use (calculating Width Of Page )
	
	UniqueID=""				&& Report Data Top Record UNIQUEID
	
	Mute=.F.

	DesignerName="Report Designer"
	UseDE=.F.
	
	** Initialize Bands
	
	Add Object TitleBand As TitleBandClass
	Add Object PageHeaderBand As PageHeaderBandClass
	Add Object DetailBand As DetailBandClass
	Add Object PageFooterBand As PageFooterBandClass
	Add Object SummaryBand As SummaryBandClass
	
	*:********************************************************************
	*:
	*: Method : Destroy of class QuickReport
	*:
	*:********************************************************************
	Procedure Destroy as VOID HelpString "Destroy FrObj"
	With This
		If Used(.ReportName)
			Use In Select(.ReportName)
		Endif
		If .Tmpfile And File(.ReportFile)
			Erase (.ReportFile)
		Endif
		If .Tmpfile And File(.ReportMemo)
			Erase (.ReportMemo)
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Create of class QuickReport
	*:
	*:********************************************************************
	Procedure Create( m.oGrid, m.cCaption )
	With This
		Local m.fail, m.all, m.info, i, k, m.Format, m.Picture, m.TotalCount

		If Vartype(m.oGrid)='O' And m.oGrid.BaseClass='GRID'
			.ReportSource=m.oGrid.RecordSource
		Else
			Messagebox("      ",16,'Quick Report')
			Return .F.
		Endif
		
		.CreateFile()
		
		If Empty(m.cCaption)
			If Type('oGrid.Parent')='O' And oGrid.Parent.BaseClass='FORM'
				.Title=oGrid.Parent.Caption
			Endif
		Else
			.Title=m.cCaption
		Endif
		If Empty(.Title)
			.Title=Tran(Date(),'@YL')+' '+Alias(.ReportSource)
		Endif
		
		If not .Mute
			m.info=info(" "+Chr(13)+.Title)
		EndIf
		
		For i=1 To m.oGrid.ColumnCount
			If m.oGrid.Columns[i].Visible and m.oGrid.Columns[i].Width > 0
				.Width=.Width+m.oGrid.Columns[i].Width+COLUMN_SEPARATOR
			EndIf
		Next
		
		If .Orientation=PAGE_AUTOMATIC
			If .Width > LAND_WIDTH
				If Messagebox(;
						"     ."+Chr(13)+;
						"     "+;
						"         ."+Chr(13)+Chr(13)+;
						"   ?",4+48+256," ") # 6
					
					Return .F.
					
				Endif
			Endif
			If .Width > PORT_WIDTH
				.Width=LAND_WIDTH
				.Orientation=PAGE_LANDSCAPE
			Else
				.Orientation=PAGE_PORTRAIT
			Endif
		Endif
		
		.PrintSetup()
		
		**** Initialize Bands
		.TitleBand.Create()
	
		.PageHeaderBand.Create()	&& Always must be !!!
		.DetailBand.Create()		&& Always must be !!!
		.PageFooterBand.Create(0)	&& Always must be !!! Here force to set zero height band
		
		**** Formatting report
		
		.TitleBand.Header(0,.Title)	&& Report Title in TITLEBAND
		
		.PageHeaderBand.Line(LINE_AT_TOP)		&& Two horizontal lines in page header band
		.PageHeaderBand.Line(LINE_AT_BOTTOM)
		
		.DetailBand.Line(LINE_AT_BOTTOM)		&& Underline detail band
		
		***** Calculate Width Of Columns
		
		m.TotalCount=0
		.Width=0
		
		With m.oGrid
			If Vartype(.Summary)='C' and not Empty(.Summary)
				m.TotalCount=GetWordCount(.Summary," ,;")
				If m.TotalCount > 0
					Local Array Totals[m.TotalCount,4]
					For i=1 to m.TotalCount
						Totals[i,1]=GetWordNum(.Summary,i," ,;")
						Totals[i,2]=0
						Totals[i,3]=0
						Totals[i,4]=""
					Next
				EndIf
			EndIf

			This.Width=0
			For i=1 To .ColumnCount
				m.Width=.Columns[i].Width
				If m.Width = 0 or not .Columns[i].Visible
					Loop
				EndIf
				For Each o In .Columns[i].Controls
					If o.BaseClass='Header' 
						This.PageHeaderBand.Header(This.Width,o.Caption)
					Endif
				Endfor
				m.Format=Alltrim(.Columns[i].Format)
				m.Picture=Alltrim(.Columns[i].InputMask)
				If '@' $ m.Picture
					m.Format=Getwordnum(m.Picture,1)
					m.Picture=Substr(m.Picture,Atc(" ",m.Picture)+1)
				Else
					If !Empty(m.Format)
						m.Format='@'+m.Format
					Endif
				Endif

				If m.TotalCount > 0
					k=Ascan(Totals,.Columns[i].ControlSource,1,Alen(Totals,1),1,3)
					If k > 0
						Totals[k,2]=This.Width
						Totals[k,3]=.Columns[i].Width
						Totals[k,4]=m.Format+' '+m.Picture
					EndIf
				EndIf

				This.DetailBand.Field(This.Width,.Columns[i].ControlSource,.Columns[i].Width,m.Format+' '+m.Picture)
				
				If i < .ColumnCount
					This.PageHeaderBand.Separator(This.Width+m.Width+COLUMN_SEPARATOR/2)
					This.DetailBand.Separator(This.Width+m.Width+COLUMN_SEPARATOR/2)
				Endif
				This.Width=This.Width+m.Width+COLUMN_SEPARATOR
			Next
		Endwith
		If m.TotalCount > 0
			.SummaryBand.Create()
			.SummaryBand.FontBold=.T.
			For i=1 to m.TotalCount
				.SummaryBand.Field(Totals[i,2],Totals[i,1],Totals[i,3],Totals[i,4],TOTAL_SUM)
			Next
		EndIf

		If .UseDE
			.AddDE()
			.AddCursor()
		EndIf

	Endwith
	
	*:********************************************************************
	*:
	*: Method : Show of class QuickReport
	*:
	*:********************************************************************
	Procedure Show( m.nAction )
	With This
		If Vartype(m.nAction)='N'
		Else
			m.nAction=ACTION_PRINT
		Endif
		If Used(.ReportName)
			Use In Select(.ReportName)
		Endif

		Compile Report (.ReportName)
		
		Select (.ReportSource)
		Local m.xFor, m.xWhile
		If Not Empty(.For) And Vartype(.For)='C'
			xFor=" FOR "+.For
		Else
			xFor=""
		Endif
		If Not Empty(.While) And Vartype(.While)='C'
			xWhile=" WHILE "+.While
		Else
			xWhile=""
		Endif
		Do Case
		Case m.nAction=ACTION_PRINT
			Report Form (.ReportFile) &xFor &xWhile Range .From,.To Noconsole To Printer Prompt
		Case m.nAction=ACTION_PREVIEW
			Report Form (.ReportFile) &xFor &xWhile Range .From,.To Preview In Screen To Printer Prompt
		Case m.nAction=ACTION_MODIFY
			Push Menu _MSYSMENU
			Define Pad ReportPreview of _MSYSMENU Prompt ""
			On Pad ReportPreview of _MSYSMENU Activate Popup ReportPreview
			Define Popup ReportPreview margin relative
			Define Bar _MFI_PREVU of ReportPreview Prompt " " pictres _MFI_PREVU
		
			Modify Report (.ReportFile) In Screen

			Pop Menu _MSYSMENU

		Endcase
	Endwith
	
	*:********************************************************************
	*:
	*: Method : CreateFile of class QuickReport
	*:
	*:********************************************************************
	Procedure CreateFile
	With This
		If Empty(.ReportName)
			.ReportName=Sys(3)
			.Tmpfile=.T.
		Endif
		If Empty(.ReportFile)
			.ReportFile=ForceExt(.ReportName,'FRX')
			.ReportMemo=ForceExt(.ReportName,'FRT')
		Endif
		If File(.ReportFile)
			Erase (.ReportFile)
			Erase (.ReportMemo)
		Endif
		
		Create Table (.ReportFile) Free ;
			(Platform   C(8),;
			UniqueID   C(10),;
			Timestamp  N(10),;
			Objtype    N(2),;
			Objcode    N(3),;
			Name       M,;
			Expr       M,;
			Vpos       N(9,3),;
			Hpos       N(9,3),;
			Height     N(9,3),;
			Width      N(9,3),;
			Style      M,;
			Picture    M,;
			Order      M,;
			'Unique'	L,;
			Comment    M,;
			Environ    L,;
			Boxchar    C(1),;
			Fillchar   C(1),;
			Tag        M,;
			Tag2       M,;
			Penred     N(5),;
			Pengreen   N(5),;
			Penblue    N(5),;
			Fillred    N(5),;
			Fillgreen  N(5),;
			Fillblue   N(5),;
			Pensize    N(5),;
			Penpat     N(5),;
			Fillpat    N(5),;
			Fontface   M,;
			Fontstyle  N(3),;
			Fontsize   N(3),;
			Mode       N(3),;
			Ruler      N(1),;
			Rulerlines N(1),;
			Grid       L,;
			Gridv      N(2),;
			Gridh      N(2),;
			Float      L,;
			Stretch    L,;
			Stretchtop L,;
			Top        L,;
			Bottom     L,;
			Suptype    N(1),;
			Suprest    N(1),;
			Norepeat   L,;
			Resetrpt   N(2),;
			Pagebreak  L,;
			Colbreak   L,;
			Resetpage  L,;
			General    N(3),;
			Spacing    N(3),;
			Double     L,;
			Swapheader L,;
			Swapfooter L,;
			Ejectbefor L,;
			Ejectafter L,;
			Plain      L,;
			Summary    L,;
			Addalias   L,;
			Offset     N(3),;
			Topmargin  N(3),;
			Botmargin  N(3),;
			Totaltype  N(2),;
			Resettotal N(2),;
			Resoid     N(3),;
			Curpos     L,;
			Supalways  L,;
			Supovflow  L,;
			Suprpcol   N(1),;
			Supgroup   N(2),;
			Supvalchng L,;
			Supexpr    M,;
			User       M)
		
		* Insert Report Header Record
		
		.UniqueID=Sys(2015)
		Insert Into (.ReportName ) ;
			( Platform;
			, UniqueID;
			, Objtype;
			, Objcode;
			, Ruler ;
			) Values ;
			( 'WINDOWS' ;
			, .UniqueID ;
			, OBJTYPE_REPORT;
			, OBJCODE_REPORT;
			, RULER_PIXEL ;
			)
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : PrintSetup of class QuickReport
	*:
	*:********************************************************************
	Procedure PrintSetup
	* Prepare Print setup data for report
	
	With This
		If Not Used(.ReportName)
			Return .F.
		Endif
		If Empty(.UniqueID)
			Return .F.
		Endif
		
		Local tmp[1], m.prtName, m.prtOut, j
		
		=Aprint(tmp)
		If Ascan(tmp,Set("PRINT",3))>0
			j=Asub(tmp,Ascan(tmp,Set("PRINT",3)),1)
			m.prtName=tmp[j,1]
			m.prtOut=tmp[j,2]
		Else
			m.prtName=Set('PRINT',3)	&& Default foxpro printer
			m.prtOut=""
		Endif
		
		m.Prt=""
		m.Prt=m.Prt+"DRIVER=WINSPOOL"+CRLF
		m.Prt=m.Prt+"DEVICE="+m.prtName+CRLF
		m.Prt=m.Prt+"OUTPUT="+m.prtOut+CRLF
		m.Prt=m.Prt+"ORIENTATION="+Alltrim(Str(.Orientation))+CRLF
		m.Prt=m.Prt+"PAPERSIZE="+Alltrim(Str(Prtinfo(2)))+CRLF
		m.Prt=m.Prt+"PAPERLENGTH="+Alltrim(Str(Prtinfo(3)))+CRLF
		m.Prt=m.Prt+"PAPERWIDTH="+Alltrim(Str(Prtinfo(4)))+CRLF
		m.Prt=m.Prt+"COPIES="+Alltrim(Str(.Copies))+CRLF
		m.Prt=m.Prt+"DEFAULTSOURCE="+Alltrim(Str(Prtinfo(7)))+CRLF
		m.Prt=m.Prt+"PRINTQUALITY="+Alltrim(Str(Prtinfo(8)))+CRLF
		m.Prt=m.Prt+"DUPLEX="+Alltrim(Str(Prtinfo(10)))+CRLF
		m.Prt=m.Prt+"YRESOLUTION="+Alltrim(Str(Prtinfo(11)))+CRLF
		m.Prt=m.Prt+"TTOPTION="+Alltrim(Str(Prtinfo(12)))+CRLF
		
		Select (.ReportName)
		Locate For UniqueID=.UniqueID
		If Found()
			Replace Expr With m.Prt
		Endif
		
	Endwith

	Procedure AddDE
	With this
		Select (.ReportName)

		Append Blank
		Replace ;
			Platform	With 'WINDOWS',;
			UniqueID	With Sys(2015),;
			Objtype		With OBJTYPE_ENV,;
			Name 		With "dataenvironment",;
			Expr 		With ;
				[AutoCloseTables = .F.]+CR+;
				[Name = "dataenvironment"]+CR ;


*!*				Tag 		With ;
*!*					[PROCEDURE Init]+CR+;
*!*					[Zoom Window "]+.DesignerName+[" max]+CR+;
*!*					[ENDPROC]


	EndWith

	Procedure AddCursor
	With this
		Local m.dbf,s
		s=""
		m.dbf=Dbf(.ReportSource)

		If File(m.dbf)
			Select (.ReportName)
			Append Blank
			Replace ;
				Platform	With 'WINDOWS',;
				UniqueID	With Sys(2015),;
				Objtype		With OBJTYPE_CURSOR,;
				Name 		With "cursor",;
				Expr 		With ;
					[CursorSource = ]+Lower(Sys(2014,Dbf(.ReportSource)))+[]+CR+;
					[Alias = "]+Lower(Alias(.ReportSource))+["]+CR+;
					[Name = "cursor1" ]+CR

		EndIf
	EndWith
Enddefine


*:********************************************************************
*:
*:    Class : TitleBandClass based on Band
*:
*:********************************************************************
Define Class TitleBandClass As Band
	Objcode=BAND_TITLE
	FontSize=12
	FontBold=.T.
Enddefine

*:********************************************************************
*:
*:    Class : PageHeaderBandClass based on Band
*:
*:********************************************************************
Define Class PageHeaderBandClass As Band
	Objcode=BAND_HEADER
	FontBold=.T.
Enddefine

*:********************************************************************
*:
*:    Class : PageFooterBandClass based on Band
*:
*:********************************************************************
Define Class PageFooterBandClass As Band
	Objcode=BAND_FOOTER
	FontBold=.T.
Enddefine

*:********************************************************************
*:
*:    Class : DetailBandClass based on Band
*:
*:********************************************************************
Define Class DetailBandClass As Band
	Objcode=BAND_DETAIL
	
Enddefine

*:********************************************************************
*:
*:    Class : SummaryBandClass based on Band
*:
*:********************************************************************
Define Class SummaryBandClass As Band
	Objcode=BAND_SUMMARY
Enddefine

*:********************************************************************
*:
*:    Class : Band based on Control
*:
*:********************************************************************
Define Class Band As Control
	Objcode=0	&& Type Of BAND
	
	Height=0	&& Height of Band
	Top=0		&& Top coordinate of band
	Width=0		&& Width Of Band
	Left=0		&& Reserved
	
	BandHeight=BAND_HEIGHT	&& Band Height Of Report Designer
	
	FontName='Arial Narrow'
	FontSize=9
	FontBold=.F.
	FontItalic=.F.
	FontUnderline=.F.
	FontOutline=.F.
	FontShadow=.F.
	FontCondense=.F.
	FontExtend=.F.
	FontStrikethru=.F.
	
	UniqueID=""	&& Unique value in Report File for the band
	
	*:********************************************************************
	*:
	*: Method : Init of class Band
	*:
	*:********************************************************************
	Procedure Init
	With This
		
		.Height=.FontHeight()
		.Width=.Pixel2Frx(PORT_WIDTH)
		
	Endwith
	
	
	*:********************************************************************
	*:
	*: Method : Pixel2Frx of class Band
	*:
	*:********************************************************************
	Procedure Pixel2Frx(nPixels )
	* For aspect 96x96
	Return Int(nPixels*100/96*100)
	
	*:********************************************************************
	*:
	*: Method : FontHeight of class Band
	*:
	*:********************************************************************
	Procedure FontHeight
	With This
		Return .Pixel2Frx(Fontmetric(1,.FontName,.FontSize,.FontStyle('')))
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Style of class Band
	*:
	*:********************************************************************
	Procedure FontStyle( m.Type )
	* Return Numeric or character style value
	* "BIUOSCE-"
	With This
		If Vartype(m.Type)='L'
			m.Type='C'
		Else
			m.Type=Vartype(m.Type)
		Endif
		
		Local m.Fontstyle
		Do Case
		Case m.Type='N'
			m.Fontstyle=0
			m.Fontstyle=m.Fontstyle+Iif(.FontBold,1,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontItalic,2,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontUnderline,4,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontOutline,8,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontShadow,16,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontCondense,32,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontExtend,64,0)
			m.Fontstyle=m.Fontstyle+Iif(.FontStrikethru,128,0)
			Return m.Fontstyle
		Case m.Type='C'
			m.Fontstyle=""
			m.Fontstyle=m.Fontstyle+Iif(.FontBold,"B","")
			m.Fontstyle=m.Fontstyle+Iif(.FontItalic,"I","")
			m.Fontstyle=m.Fontstyle+Iif(.FontUnderline,"U","")
			m.Fontstyle=m.Fontstyle+Iif(.FontOutline,"O","")
			m.Fontstyle=m.Fontstyle+Iif(.FontShadow,"S","")
			m.Fontstyle=m.Fontstyle+Iif(.FontCondense,"C","")
			m.Fontstyle=m.Fontstyle+Iif(.FontExtend,"E","")
			m.Fontstyle=m.Fontstyle+Iif(.FontStrikethru,"-","")
			Return m.Fontstyle
		Endcase
		Return .Null.
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Header of class Band
	*:
	*:********************************************************************
	Procedure Header( m.PixelLeft, m.cCaption, m.Width )
	* Band Text
	With This
		.NewRecord(OBJTYPE_TEXT)
		Replace Vpos		With .Top,;
			Hpos		With .Pixel2Frx(m.PixelLeft),;
			Expr		With '"'+m.cCaption+'"',;
			Height		With .Height,;
			Width		With .TextWidth(m.cCaption),;
			Supalways	With .T.
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Field of class Band
	*:
	*:********************************************************************
	Procedure Field( m.PixelLeft, m.cSource, m.Width, m.Picture, m.nTotalType)
	* Band Field
	With This
		.NewRecord(OBJTYPE_EXPR)
		Local m.Offset
		
		Select (.Parent.ReportSource)
		* Requires for correct establish field type
		* Right alignment always for numeric, integer and currency values
		
		m.Offset=Iif(Inlist(Type(m.cSource),'N','Y','I'),1,0)
		Select (.Parent.ReportName)
		
		Replace ;
			Vpos		With .Top,;
			Hpos		With .Pixel2Frx(m.PixelLeft),;
			Expr		With m.cSource,;
			Height		With .Height,;
			Width		With .Pixel2Frx(m.Width),;
			Picture		With Iif(Empty(m.Picture),"",'"'+m.Picture+'"'),;
			Supalways	With .T.,;
			Stretch		With .T.,;
			Offset		With m.Offset

		If Vartype(m.nTotalType)="N"
			Replace ;
				TotalType	with m.nTotalType,;
				ResetTotal	with 1,;
				FontStyle	with .FontStyle(1) && Bold
		EndIf
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Separator of class Band
	*:
	*:********************************************************************
	Procedure Separator( m.PixelLeft )
	* Insert Column Separator (vertical) line
	With This
		.NewRecord(OBJTYPE_LINE)
		Replace Vpos		With .Top,;
			Hpos		With .Pixel2Frx(m.PixelLeft),;
			Width		With .Pixel2Frx(1),;
			Height		With .Height,;
			Supalways	With .T.,;
			Stretch		With .T.
		
		* Always Stretch
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Line of class Band
	*:
	*:********************************************************************
	Procedure Line(m.nPosition )
	* Insert horizontal line for an band width
	* nPositon - 0 - is Top, 1 is Bottom
	With This
		m.nPosition=Iif(Empty(m.nPosition) Or Vartype(m.nPosition)#'N',LINE_AT_TOP,m.nPosition)
		.NewRecord(OBJTYPE_LINE)
		Replace ;
			Vpos		With .Top+Iif(m.nPosition=LINE_AT_TOP,0,.Height),;
			Hpos		With 0,;
			Width		With .Width,;
			Height		With .Pixel2Frx(1),;
			Supalways	With .T.
		
		Do Case
		Case m.nPosition=LINE_AT_TOP
			Replace Top With .T.
		Case m.nPosition=LINE_AT_BOTTOM
			Replace Bottom With .T.
		Case m.nPosition=LINE_FLOAT
			Replace Float With .T.
		Endcase
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : NewRecord of class Band
	*:
	*:********************************************************************
	Procedure NewRecord( m.Objtype, m.Objcode )
	* Create New Record in REPORT file
	With This
		If Not Used(.Parent.ReportName)
			Return .F.
		Endif
		If Vartype(m.Objtype) # 'N'
			m.Objtype=OBJTYPE_EXPR
		Endif
		If Vartype(m.Objcode) # 'N'
			m.Objcode=0
		Endif
		
		Select (.Parent.ReportName)
		
		Append Blank
		Replace ;
			Platform	With 'WINDOWS',;
			UniqueID	With Sys(2015),;
			Objtype		With m.Objtype,;
			Objcode		With m.Objcode
		
		If Inlist(m.Objtype,OBJTYPE_EXPR,OBJTYPE_TEXT)
			* Fields for B&W laser printer, fields transparent
			
			Replace ;
				Penred		With 0,;
				Pengreen	With 0,;
				Penblue		With 0,;
				Fillred		With -1,;
				Fillgreen	With -1,;
				Fillblue	With -1,;
				Fontface	With .FontName,;
				FontSize	With .FontSize,;
				Fontstyle	With .FontStyle(0),;
				Mode		With MODE_TRANS
			
		Endif
		
		If Inlist(m.Objtype,OBJTYPE_LINE,OBJTYPE_BOX)
			Replace ;
				Penred		With -1,;
				Pengreen	With -1,;
				Penblue		With -1,;
				Fillred		With -1,;
				Fillgreen	With -1,;
				Fillblue	With -1,;
				Penpat		With 8
			
		Endif
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Create of class Band
	*:
	*:********************************************************************
	Procedure Create( m.nForceHeight )
	With This
		If PCount() > 0
			.Height=m.nForceHeight
		Endif
		.Top=.Parent.Top
		.Parent.Top=.Top+.Height+.BandHeight
		.Width=.Pixel2Frx(.Parent.Width)
		
		.NewRecord(OBJTYPE_BAND, .Objcode )

		Select (.Parent.ReportName)

		Replace Height 	With .Height,;
				Width	With .Width
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : TextWidth of class Band
	*:
	*:********************************************************************
	Procedure TextWidth( m.Text, m.Offset )
	* For the fields - width must be increased by 2 pixels
	With This
		Local o, m.ret
		m.ret=0
		o=Create('QuickReportForm')
		With o
			.Visible=.T.
			With o.Label
				.Visible=.T.
				.FontName=This.FontName
				.FontSize=This.FontSize
				.FontBold=This.FontBold
				.FontItalic=This.FontItalic
				
				.Caption=m.Text
				.AutoSize=.T.
				
				m.ret=.Width+Iif(Not Empty(m.Offset),m.Offset,0)
			Endwith
		Endwith
		o.Release
		Return .Pixel2Frx(m.ret)
	Endwith
Enddefine

*:********************************************************************
*:
*:    Class : QuickReportForm based on Form
*:
*:********************************************************************
Define Class QuickReportForm As Form
	* Form Must be VISIBLE but we don't want see them
	* Hide Form
	Top=-1000
	Left=-1000
	
	Add Object Label As Label With Left=0,Top=0
	
Enddefine
*: End of frxobj.prg
