*:********************************************************************
*:
*: Procedure file :CLASSES.PRG
*:
*: Contents :
*: 
*: 		Class     PrintDocument AS PrintClass
*: 
*: 		Class     PrintClass AS ustom
*: 
*: 		Class     Report AS BaseClass
*: 
*: 		Class     Reports AS BaseClass
*: 
*: 		Class     ReportSeparator AS Report
*: 
*: 		Class     ReportDelimiter AS Report
*:
*: (c) Piva, BEAR v.42 on 29.01.2003 12:50
*:********************************************************************
*    Fox'    VCL
*      PRG  - 
* "   -   " (  )
*
*   .. 1999
* 24.12.1999 00:37

#include include/main.h


*:********************************************************************
*:
*:    Class : PRINTDOCUMENT based on PRINTCLASS
*:
*:********************************************************************
Define Class PrintDocument as PrintClass
	DocumentType=""
	DocumentForm=""		&&  
	DocumentTitle=""
	ListForm=""			&&   
	ListTitle=""
	Owner=.null.		&&  
	Customer=.null.		&&  
	DocID=""			&&  
	Document=.null.
	
	*:********************************************************************
	*:
	*: Method : INIT of class PRINTDOCUMENT
	*:
	*:********************************************************************
	Procedure Init
	With this
		If type('.parent')#'O'
			Messagebox("       ",48,_screen.caprion)
			Return .F.
		Endif
		If vartype(.Parent.Record)='O' ;
				and Vartype(.Parent.Record.DocID)='C'
			
			.DocID=.Parent.Record.DocID
			
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : PRINTDOCUMENT of class PRINTDOCUMENT
	*:
	*:********************************************************************
	Procedure PrintDocument( nAction )
	Local m.ReportFile
	With this
		
		If not empty(.Parent.Alias)
			.Alias=.Parent.Alias
		Else
			.Alias=ALIAS()
		Endif
		
		.DocID=.Parent.Record.DocID
		.For=.Alias+'.DOCID=['+.DocID+']'
		
		Select Account
		Locate for AccountID=.Parent.Record.OwnerID
		If found()
			Scatter memo name .Owner
			m.ReportFile=ReadMemo(.DocumentType,.Owner.Reports)
			If not empty(m.ReportFile)
				.DocumentForm=m.ReportFile
			Else
				.DocumentForm=.DocumentType
			Endif
		Else
			Scatter memo name .Owner blank
		Endif
		
		Select Account
		Loca for AccountID=.Parent.Record.AccountID
		If found()
			Scatter memo name .Customer
		Else
			Scatter memo name .Customer blank
		Endif
		
		Select (.Alias)
		Scatter memo name .document
		
		.FormFile=.DocumentForm
		.Title=.Parent.Title
		
		PrintClass::Print(nAction)
		
	Endwith
	
	
	*:********************************************************************
	*:
	*: Method : PRINTLIST of class PRINTDOCUMENT
	*:
	*:********************************************************************
	Procedure PrintList( nAction )
	With this
		If not empty(.Parent.Alias)
			.Alias=.Parent.Alias
		Else
			.Alias=ALIAS()
		Endif
		Select (.Alias)
		.FormFile=.ListForm
		.Title=.Parent.ListCaption
	Endwith
	PrintClass::Print(nAction)
	
	*:********************************************************************
	*:
	*: Method : PRINT of class PRINTDOCUMENT
	*:
	*:********************************************************************
	Procedure Print( nAction )
	With this
		If type('_SCREEN.ACTIVEFORM')='O'
			
			Do case
			Case vartype(.Parent.Form)='O' ;
					and .Parent.Form=_SCREEN.ActiveForm
				
				.DocID=.Parent.Record.DocID
				.PrintDocument(nAction)
				
			Case vartype(.Parent.ViewForm)='O' ;
					and .Parent.ViewForm=_SCREEN.ActiveForm
				
				.PrintList( nAction )
				
			Endcase
		Endif
	Endwith
	
Enddefine

*:********************************************************************
*:
*:    Class : PRINTCLASS based on CUSTOM
*:
*:********************************************************************
Define class PrintClass AS Custom 
	Protected macro
	
	FormFile = ""
	Title = ""
	SubTitle=""
	
	*-- Specifies the alias used for each table or view associated with a Cursor object.
	Alias = ""
	action = 0
	Orientation = 0
	For = ""
	While = ""
	Macro = ""
	Copies = 1
	uuid = ""
	uuid_mask='XXXXXXXXXXXXXXXXXXXX'
	
	startpage = 1
	endpage = 9999
	
	Prompt = .F.
	showdlg = .F.
	Copies = 1
	
	Recno=0
	
	Document=.null.
	
	*:********************************************************************
	*:
	*: Method : PROCESS of class PRINTCLASS - PROTECTED
	*:
	*:********************************************************************
	Protected PROCEDURE Process(nAction)
	With this
		.Action=iif(empty(nAction),0,nAction)
		If Not .MakeMacro()
			Return .F.
		Endif
		
		.Recno=Recno(.Alias)
		
		Do case
		Case .action=0
			Local s, cPrompt
			s=.Macro
			cPrompt=iif(This.Prompt,'PROMPT','')
			
			_Pcopies=This.Copies
			If !between(_pcopies,1,32767)
				_Pcopies=1
			Endif
			Print
				
				Report FORM (This.FormFile) &s ;
					NOEJECT NOCONSOLE ;
					RANGE this.startpage, this.endpage ;
					TO PRINTER &cPrompt
				
			Endprint
			_Pcopies=1
			
		Case .action=1
			
			Push menu _MSYSMENU
			
			Release bar OP_PRINTSETUP of FILE
			Release bar OP_PRINT of FILE
			Release bar OP_PREVIEW of FILE
			Release bar OP_PRINTMODIFY Of File
			Define Bar _MFI_PGSET of FILE after _MFI_SP300 prompt '\< '
			Define Bar _MFI_SYSPRINT of FILE after _MFI_PGSET prompt '\<...' key KEY_PRINT
			
			Local s
			s=.Macro
			Report FORM (.FormFile) NOEJECT NOCONSOLE PREVIEW &s
			
			Pop Menu _MSYSMENU
			
		Case .action=2
			
			Push menu _MSYSMENU
			
			Release bar OP_PRINTSETUP of FILE
			Release bar OP_PRINT of FILE
			Release bar OP_PREVIEW of FILE
			Release bar OP_PRINTMODIFY Of File
			Define Bar _MFI_PGSET of FILE after _MFI_SP300 prompt '\< '
			Define Bar _MFI_PREVU of FILE after _MFI_PGSET prompt ' ' key KEY_PREVIEW
			Define Bar _MFI_SYSPRINT of FILE after _MFI_PREVU prompt '\<...' key KEY_PRINT
			
			Define Bar _MSM_VIEW of _MSYSMENU Prompt '\<View' key alt+v
			Define Popup _MVIEW margin relative
			Define Bar _MVI_TOOLB of _MVIEW Prompt '\<Toolbars'
			
			Modify REPORT (this.FormFile) in SCREEN
			
			Pop menu _msysmenu
			
		Other
			Messagebox("   ",48,.Title)
		Endcase
		
		DoEvents()

		If Between(.Recno,1,Reccount(.Alias))
			Go (.Recno) in (.Alias)
		Endif
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : PREVIEW of class PRINTCLASS
	*:
	*:********************************************************************
	Procedure preview(nAction)
	Return This.Process(nAction)
	
	
	*:********************************************************************
	*:
	*: Method : PRINTMODIFY of class PRINTCLASS
	*:
	*:********************************************************************
	Procedure printmodify(nAction)
	Return This.Process(nAction)
	
	
	*-- Prints a character string on a Form object.
	*:********************************************************************
	*:
	*: Method : PRINT of class PRINTCLASS
	*:
	*:********************************************************************
	Procedure print(nAction)
	Return This.Process(nAction)
	
	*:********************************************************************
	*:
	*: Method : MAKEMACRO of class PRINTCLASS - PROTECTED
	*:
	*:********************************************************************
	Protected Procedure MakeMacro
	With THIS
		If not VarType(.FormFile)='C' or Empty(.FormFile)
			Messagebox("   .",16,'')
			Return .F.
		Endif
		.FormFile=DefaultExt(.FormFile,'FRX')
		If Empty(JustPath(.FormFile))
			.FormFile=AddBS(_REPORTS)+.FormFile
		Endif
		.FormFile=Full(.FormFile)
		If not File(.FormFile)
			Messagebox("    "+.FormFile+".",16,'')
			Return .F.
		Endif
		
		s=SYS(2015)
		.uuid=""
		For i=1 to len(s)
			.uuid=.uuid+Right(Tran(asc(substr(s,i,1)),'@X0'),2)
		Next
		.uuid=tran(.uuid,.uuid_mask)
		
		.Prompt=LocalGet("Print.Prompt",.Prompt)
		
		If Vartype(.For)='C' and !empty(.For)
		Else
			.For=""
		Endif
		If Vartype(.While)='C' and !empty(.While)
		Else
			.While=""
		Endif
		.Macro=""
		If !Empty(.For)
			.Macro=' FOR '+.For
		Endif
		If !EMpty(.While)
			.Macro=' WHILE '+.While
		Endif
		If IsShift()
			.action=1
		EndIf
		If IsCtrl()
			.action=2
		Endif
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : ERROR of class PRINTCLASS
	*:
	*:********************************************************************
	Procedure Error
	Lparameters nError, cMethod, nLine
	if nError=2028
		Return 
	endif
	
	Logerror(nError, cMethod, nLine)
	Messagebox('Message '+Message()+chr(13)+;
		'Method '+cMethod+chr(13)+;
		'Line '+num(nLine),0,'PrintClass '+num(nError))
	Endproc
	
	
Enddefine
*
*-- EndDefine: printclass

*:********************************************************************
*:
*:    Class : REPORT based on BASECLASS
*:
*:********************************************************************
Define CLASS Report AS BaseClass
	
	Title = ""				&&    \<
	SubTitle = ""
	Text = "" 				&&   
	Alias = ""				&&   
	HotKey = ""				&&  
	hotkeycaption = ""		&&  
	Picture=""				&&  
	
	windowname = ""
	objectclass = ""
	objectclasslib=""
	
	FormFile=""
	
	ClsID=""

	OwnerID=""
	CustID=""
	GroupID=""
	ItemID=""
	DateMin={}
	DateMax={}

	MinOwnerID=""
	MaxOwnerID=""

	MinCustID=""
	MaxCustID=""

	MinGroupID=""
	MaxGroupID=""

	MinItemID=""
	MaxItemID=""


	*:********************************************************************
	*:
	*: Method : PREVIEW of class REPORT
	*:
	*:********************************************************************
	Procedure Preview(nAction)
	This.Print(1)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : PRINTMODIFY of class REPORT
	*:
	*:********************************************************************
	Procedure PrintModify(nAction)
	This.Print(2)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : INIT of class REPORT
	*:
	*:********************************************************************
	Procedure Init
	Lparameter m.cObjectName, m.cTitle, m.cAlias
	With this
		If not DoDefault()
			Return .F.
		Endif
		If char( m.cObjectName )
			.ObjectName=m.cObjectName
		Endif
		If char( m.cTitle )
			.Title=m.cTitle
		Endif
		If char( m.cAlias )
			.Alias=m.cAlias
		Endif
	Endwith
	Endproc
	
	
	*-- Specifies if an item is selected in a ComboBox or ListBox control.
	*:********************************************************************
	*:
	*: Method : SELECTION of class REPORT
	*:
	*:********************************************************************
	Procedure selection
	With this
		Return .GetParameters()
	Endwith
	Endproc
	
	*:********************************************************************
	*:
	*: Method : GETPARAMETERS of class REPORT
	*:
	*:********************************************************************
	Procedure GetParameters
	Local ok, m.query
	With this
		Local m.Query, ok
		.LoadParm()
		m.Query=Query()
		If not .HookForm(m.Query)
			Release m.Query
			Return .F.
		EndIf
		With m.Query
			.Caption=This.Title
			.Text.Caption=Iif(Empty(this.Text),.Text.Caption,This.Text)
			.DateMin=this.DateMin
			.DateMax=Iif(this.DateMax=C_MAX_DATE,{},this.DateMax)
			.OwnerID=this.OwnerID
			.CustID=this.CustID
			.GroupID=this.GroupID
			.ItemID=this.ItemID

			.Show(1)

			ok=.Tag='OK'
			If ok
				This.OwnerID=.Owner.Value
				This.CustID=.Customer.Value
				This.GroupID=.Group.Value
				This.ItemID=.Item.Value
				This.DateMin=.Dates.DateMin.Value
				This.DateMax=.Dates.DateMax.Value
				This.DateMax=Iif(Empty(This.DateMax),C_MAX_DATE,This.DateMax)
			EndIf
		EndWith	
		If ok
			.SaveParm()
		EndIf
		Return ok
	Endwith
	Endproc
	
	*:********************************************************************
	*:
	*: Method : HOOKFORM of class REPORT
	*:
	*:********************************************************************
	Procedure HookForm(oForm)
	with oForm
	endwith
	
	*:********************************************************************
	*:
	*: Method : SAVEPARM of class REPORT
	*:
	*:********************************************************************
	Procedure SaveParm
	With this
		.ExpandParameters()
		SaveQueryPref(.clsid,this)
	Endwith
	
	*:********************************************************************
	*:
	*: Method : LOADPARM of class REPORT
	*:
	*:********************************************************************
	Procedure LoadParm
	With this
		ReadQueryPref(.clsid,this)
		.ExpandParameters()
	Endwith
	
	Procedure ExpandParameters
	With this
		If Empty(.OwnerID)
			.MinOwnerID=C_MIN_UNIQUEID
			.MaxOwnerID=C_MAX_UNIQUEID
		Else
			.MinOwnerID=.OwnerID
			.MaxOwnerID=.OwnerID
		EndIf
		If Empty(.CustID)
			.MinCustID=C_MIN_UNIQUEID
			.MaxCustID=C_MAX_UNIQUEID
		Else
			.MinCustID=.CustID
			.MaxCustID=.CustID
		EndIf
		If Empty(.GroupID)
			.MinGroupID=C_MIN_UNIQUEID
			.MaxGroupID=C_MAX_UNIQUEID
		Else
			.MinGroupID=.GroupID
			.MaxGroupID=.GroupID
		EndIf
		If Empty(.ItemID)
			.MinItemID=C_MIN_UNIQUEID
			.MaxItemID=C_MAX_UNIQUEID
		Else
			.MinItemID=.ItemID
			.MaxItemID=.ItemID
		EndIf
	EndWith	
	
	*:********************************************************************
	*:
	*: Method : PRINT of class REPORT
	*:
	*:********************************************************************
	Procedure Print( nWhat )
	Local o
	With this
		o=Create("PrintClass")
		o.Title=.Title
		o.SubTitle=.SubTitle
		o.FormFile=.FormFile
		o.Alias=.Alias
		o.Print(nWhat)
	Endwith
	
	
	*:********************************************************************
	*:
	*: Method : SHOW of class REPORT
	*:
	*:********************************************************************
	Procedure Show( m.nShow )
	with this
		if VarType(.Form)=T_OBJECT
		else
			.NewObject('Form','MyView','View.PRG')
		endif

		Select (.Alias)
		
		.Form.Caption=.Title
		.Form.ClsID=.ClsID
		.Form.UnusedAlias=.T.
		.Form.Alias=.Alias
		.Form.Grid.RecordSource=.Alias
		
		.Browse(.Form.Grid)
		
		.Form.Grid.ReadOnly=.T.
		.Form.RestoreView()
		.Form.Resize
		.Form.Show
	endwith
	
	*:********************************************************************
	*:
	*: Method : BROWSE of class REPORT
	*:
	*:********************************************************************
	Procedure Browse( oGrid )
	
	*:********************************************************************
	*:
	*: Method : GRANT of class REPORT
	*:
	*:********************************************************************
	Procedure Grant(m.action)
	With this
		If Admin()
			Return .T.
		EndIf
		If Not Used("Grant")
			Return .F.
		EndIf
		Select Mask from Grant where Object=ChkVal(.Name) and Group=ChkVal(_UserGroup) into array tmp
		If _TALLY=0
			Return .F.
		EndIf
		Return Bittest(tmp[1],MASK_LIST)
	EndWith
	
Enddefine



*:********************************************************************
*:
*:    Class : REPORTS based on BASECLASS
*:
*:********************************************************************
Define Class Reports As BaseClass
	
	LastSelectedBar=0
	Popup='Reports'
	
	*:********************************************************************
	*:
	*: Method : INIT of class REPORTS
	*:
	*:********************************************************************
	Procedure Init
	With this
		
		If Not DoDefault()
			Return .F.
		Endif
		
		Define Pad (.Popup) of _MSYSMENU Prompt '\<' key alt+j before PadWindow Message ""
		Define Popup (.Popup) margin relative
		On Pad (.Popup) of _MSYSMENU Activate popup (.Popup)
		On Selection Popup (.Popup) ReportsSelection(bar())
	
	Endwith
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class REPORTS
	*:
	*:********************************************************************
	Procedure Destroy
	With this
		DoDefault()
		If Popup(.Popup)
			Release Pad (.Popup) of _MSYSMENU
			Release Popup (.Popup) Extended
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : CLOSE of class REPORTS
	*:
	*:********************************************************************
	Procedure Close
	
	
	*:********************************************************************
	*:
	*: Method : ADD of class REPORTS
	*:
	*:********************************************************************
	Procedure Add( m.cObjectName,m.cObjectClass, m.cObjectClassLib, m.cObjectApp)
	
	*    
	m.cObjectClassLib=iif(empty(m.cObjectClassLib),"",m.cObjectClassLib)
	m.cObjectApp=iif(empty(m.cObjectApp),CLASS_APP,m.cObjectApp)
	
	With this
		if not type('.'+m.cObjectName)='O'
			.newobject( m.cObjectName, m.cObjectClass, m.cObjectClassLib, m.cObjectApp )
			If type('.'+m.cObjectName)='O'
				
				o=eval('.'+m.cObjectName)
				.DefineBar(o)
				Return (o)
			Endif
		endif
	Endwith
	Return .null.
	Endproc
	
	*:********************************************************************
	*:
	*: Method : DEFINEBAR of class REPORTS
	*:
	*:********************************************************************
	Procedure DefineBar( oObj, m.Bar )
	With oObj
		If .Grant() and not empty(.Title)
			Local cHotKey, cHotCap, nBar
			nBar=iif(empty(m.Bar),This.ControlCount,m.Bar)
			If not empty(.HotKey)
				cHotKey=.HotKey
				cHotCap=iif(empty(.hotkeycaption),"",.hotkeycaption)
				Define Bar nBar of (This.Popup) Prompt (.Title) key &cHotKey,(cHotCap)
			Else
				Define Bar nBar of (This.Popup) Prompt (.Title)
			Endif
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : REMOVE of class REPORTS
	*:
	*:********************************************************************
	Procedure remove
	Lparameter m.cObjectName
	With this
		If type('.'+m.cObjectName)=T_OBJECT
			.RemoveObject( m.cObjectName )
		Endif
	Endwith
	Endproc
	
	
	*-- Clears the contents of a ComboBox or ListBox control.
	*:********************************************************************
	*:
	*: Method : CLEAR of class REPORTS
	*:
	*:********************************************************************
	Procedure clear
	Local o
	For each o in This.Controls
		This.RemoveObject(o.name)
	Next
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : MAKEMENU of class REPORTS
	*:
	*:********************************************************************
	Procedure makemenu
	With this
		Local s, o, cHotKey, cHotCap
		s=.Name
		Release bar ALL of (s)
		For i=1 to .ControlCount
			o=.Controls[i]
			.DefineBar(o,i)
		Next
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : SELECTION of class REPORTS
	*:
	*:********************************************************************
	Procedure selection( nBar )
	With this
		If between( nBar, 1, .ControlCount)
			.LastSelectedBar=nBar
			.Controls[nBar].Selection()
		Endif
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : FREEBAR of class REPORTS
	*:
	*:********************************************************************
	Procedure FreeBar
	* o   Bar  THIS.POPUP
	With this
		Local i, ret
		ret=0
		For i=1 to CNTBAR(.Popup)
			ret=Max(GetBar(.Popup,i),ret)
		Next
		Return ret+1
	Endwith
	
	
	*:********************************************************************
	*:
	*: Method : PRINT of class REPORTS
	*:
	*:********************************************************************
	Procedure Print ( nWhat )
	
Enddefine

*:********************************************************************
*:
*:    Class : REPORTSEPARATOR based on REPORT
*:
*:********************************************************************
Define Class ReportSeparator as Report
	Title='\-'
EndDefine

*:********************************************************************
*:
*:    Class : REPORTDELIMITER based on REPORT
*:
*:********************************************************************
Define Class ReportDelimiter as Report
	Title='\|'
EndDefine



*: End of CLASSES.PRG
