*:********************************************************************
*:
*: Procedure file :DOCUMENT.PRG
*:
*: Contents :
*: 
*: 		Class     Document AS BaseClass
*: 
*: 		Class     Contents AS BaseClass
*: 
*: 		Class     BaseClass AS Custom
*:
*: (c) Piva, BEAR v.42 on 18.03.2003 12:20
*:********************************************************************
*###   
*### r.3
*
* r.3 11:15, 30  2003 . -  ShowForm,  New  Open
*

*
#include Include\Main.h
*

Define Class MyDocument as Document
	DocumentOption=""

	Procedure GetCustomer
	with this
		Local m.CustID, m.Name
		m.CustID=.Record.CustID
		m.Name=.Record.Name

		DO GetCust with m.CustID,m.Name
	
		.Record.CustID=m.CustID
		.Record.Name=m.Name
		
		If Vartype(.Form)="O"
			.Form.Refresh
		EndIf		
	EndWith 		

	Procedure GetOwner
	with this
		DO Owner with .Record.OwnerID
	EndWith 		

	Procedure GetOption
	With this
		If not Empty(.DocumentOption)
			Local m.command
			m.command=.DocumentOption
			&command
		EndIf
	EndWith

	Procedure FormCaption
	With this
		Return .Title+" "+Caption(.Record.Number,.Record.Date)
	EndWith

EndDefine

*:********************************************************************
*:
*:    Class : DOCUMENT based on BASECLASS
*:
*:********************************************************************
Define Class Document As BaseClass
	
	Title = " "
	AccessMask = 0
	
	FormName = ""	&&--    
	FormClass = ""	&&    
	FormLib = "" 	&&     - APP,EXE
	
	ReportForm=""
	
	Child = .T. 	&&          
	
	ListClsID = ""
	ListCaption = " "
	ListForm = .Null.
	ListReportForm=""
	
	Name = "document"
	KeyField = ""
	Changes = .F.
	Modal = .F.
	Record = .Null.
	TestRecord=.Null.
	NewDocument=.F.
	Operator=""
	Saved=.F.
	Fail=.F.

	FaceMask=0

	Add Object Errors as Errors
		
	*:********************************************************************
	*:
	*: Method : NEW of class DOCUMENT
	*:
	*:********************************************************************
	Procedure New
	Lparameter m.cKey
	With this
		If Not .Grant(OP_NEW)
			Return .F.
		Endif
		If Used(.Alias)
			Select (.Alias)
			If Vartype(.Form)='O' 
				.Form.Show
				If Not .Save(.T.)
					Return .F.
				Endif
			Endif
			If not .Create()
				Return .F.
			EndIf
			.ShowForm(.T.)
		EndIf 
	EndWith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : OPEN of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Open
	Lparameter m.cKey
	If Not This.Grant(OP_OPEN)
		Return .F.
	Endif
	
	Local m.key, m.rc
	With This
		If Alias()='_'+.Alias
			If Empty(m.cKey)
				m.cKey=Eval(.KeyField)
			Endif
		Endif
		Select (.Alias)
		If Not Empty(.KeyField)
			If Not Empty(m.cKey)
				m.rc=Recno()
				If Not Seek(m.cKey,.Alias,.KeyField)
					If Between(m.rc,1,Reccount())
						Go (m.rc)
					Endif
				Endif
			Endif
			m.key=Eval(.KeyField)
			If Empty(m.key)
				Return .New()
			Endif
		Endif
		If Used(.Alias)
			Select (.Alias)
			If Vartype(.Form)='O' 
				.Form.Show
				If Not .Save(.T.)
					Return .F.
				Endif
			Endif
			If not .Load()
				Return .F.
			Endif
			.ShowForm()
		EndIf 
	Endwith
	Endproc

	*--     
	*:********************************************************************
	*:
	*: Method : SHOWFORM of class DOCUMENT
	*:
	*:********************************************************************
	Procedure ShowForm
	Lparameter m.lNew
	m.lNew=!Empty(m.lNew)
	With This
		If Used(.Alias)
			If Vartype(.Form)='O'
				.Form.Refresh
			Else
				Select (.Alias)
				If !Empty(.FormName) And !Isnull(.FormName)
					If Vartype(.Form)='U'
						.AddProperty('Form',.Null.)
					Endif
					Do Form (.FormName) Name This.Form With This
				Else
					If !Isnull(.FormClass) ;
							and !Empty(.FormClass) ;
							and !Empty(.FormLib)
						
						.Newobject('Form',.FormClass,.FormLib,CLASS_APP,This)
						If Vartype(.Form)='O'
							.Form.Visible=.T.
						Endif
					Else
						Messagebox(MSG_NO_FORM,16,This.Title)
					Endif
				Endif
			Endif
		Endif
	Endwith
	Endproc

	
	*-- Delete Event.
	*:********************************************************************
	*:
	*: Method : DELETE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Delete
	Lparameter m.cKey
	If Not This.Grant(OP_DELETE)
		Return .F.
	Endif
	
	With This
		.Fail=.T.
		If Vartype(.Form)='O'
			Messagebox("     ",48,.Title)
			Return .F.
		Endif
		If Used(.Alias)
			Select (.Alias)
			Local m.key, fail, m.rc
			m.rc=Recno()
			.Fail=.F.
			If Not Empty(m.cKey)
				If Not Seek(m.cKey,.Alias,.KeyField)
					If Between(m.rc,1,Reccount())
						Go (m.rc)
					Endif
				Endif
			Endif
			m.rc=Recno()
			Scatter Memo Name .Record
			m.key=Eval(This.KeyField)
			If !Empty(m.key)
				If Messagebox(MSG_DELETE_CURRENT,4+48+256,.Title)=6
					If .Lock()
						.Errors.Clear()
						If Not BEGIN_TRANSACTION()
							.Fail=.T.
							.Unlock()
							Return .F.
						Endif
						If .MyDelete() And .EnumChilds("Delete")
							
							* !!!    
							
							Select (.Alias)
							Go (m.rc)
							=WriteLog(.Record,'DELETE')
							Gather Memo name .Record				
							Delete
							If Commit_Transaction()
								If Not Eof()
									Skip
								Else
									Go Bottom
								Endif
								If Vartype(.ListForm)='O'
									.ListForm.Refresh()
								Endif
							Else
								.Fail=.T.
							Endif
						Else
							.Fail=.T.
							RollBack_Transaction()
						Endif
						.Unlock()
					Endif
					If Vartype(.ListForm)='O'
						.ListForm.Refresh
					Endif
					.Errors.Show()
				Endif
			Endif
			Return Not .Fail
		Endif
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : CREATE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Create
	With This
		.Fail=.F.
		Select (This.Alias)
		Scatter Memo Name .Record Blank
		If .EnumChilds("Create") and .Default()
			.Changes=.T.
			.NewDocument=.T.
			.Saved=.F.
		Else
			.Fail=.T.
		Endif
		If Vartype(.Form)='O'
			.Form.Record=.Record
		Endif
		Return not .Fail
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : LOAD of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Load
	With This
		.Fail=.F.
		Select (.Alias)
		Scatter Memo Name .Record
		If .MyLoad() And .EnumChilds("Load")
			.Changes=.F.
			.Saved=.T.
			.NewDocument=.T.
			Select (.Alias)
			If Vartype(.Form)='O'
				.Form.Record=.Record
			Endif
		Else
			.Fail=.T.
		Endif
		Return Not .Fail
	Endwith
	Endproc
	
	
	*--    
	*:********************************************************************
	*:
	*: Method : SAVE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Save
	Lparameter m.lAskOnSave
	m.lAskOnSave=!Empty(m.lAskOnSave)
	Local s, m.ThatNew, m.rc
	With This
		.Fail=.F.
		m.ThatNew=.F.
		.Saved=.F.
		If Used(.Alias)
			Select (.Alias)
			*     -    
			If .Changed() && Or Not m.lAskOnSave
				If Vartype(.Form)='O'
					.Record=.Form.Record
				Endif
			
				Local i, k, m.key, s, c, m.cKey, m.BackStamp, m.BackKey
				
				If m.lAskOnSave
					k=Messagebox(MSG_ASK_ON_SAVE,3+32,This.Title)
					Do Case
					Case k=6
						
					Case k=7
						Return .T.
					Other
						Return .F.
					Endcase
				Endif
				
				*   - ReadOnly -  
				If IsReadOnly(.Alias)
					Messagebox(MSG_READONLY,16,.Title)
					Return .F.
				Endif

				*        
				
				If Not .Tested()
					.Fail=.T.
					Return .F.
				Endif

				If Vartype(.Record.Timestamp)='T'
					m.BackStamp=.Record.Timestamp
				Endif

				s='This.Record.'+.KeyField
				m.key=GetPem(.Record,.KeyField)	&&  
				m.BackKey=m.Key
				m.cKey=.KeyField	&&  

				If Not Empty(m.key)	&&     -   
					Locate For &cKey= m.key	&&    
					If !Found()		&&    = 
						If Messagebox(MSG_NOTFOUND,4+48,.Title) # 6
							.Fail=.T.
							Return .F.
						Endif
						m.key=Blank(m.key)	&&      -  
					Endif
					*   TimeStamp  
					If Vartype(.Record.Timestamp)='T'
						If .Record.Timestamp # Timestamp
							If Messagebox(MSG_CHANGED,4+48+256,.Title) # 6
								.Fail=.T.
								Return .F.
							Endif
						Endif
					Endif
				Endif
				
				*        - 
				If Not .Lock()
					.Fail=.T.
					Return .F.
				Endif
				*     -  
				If Not BEGIN_TRANSACTION()
					.Unlock()	&&  - 
					.Fail=.T.
					Return .F.
				Endif
				
				.Errors.Clear()		&& Init Errors object

				If Empty(m.key)		&&   
					m.ThatNew=.T.
					Append Blank
					Do Case
					Case Type(s)='C'
						Store CID_PROC To (s)	&&   
					Case Inlist(Type(s),'N','I')
						Store NID_PROC To (s)
					Other
						RollBack_Transaction()
						.UnLock()
						.Fail=.T.
						.Errors.Add(MSG_INVALID_KEY)
					Endcase
					
					If Empty(Eval(s))
						RollBack_Transaction()
						.Unlock()
						.Fail=.T.
						.Errors.Show()
						Return .F.
					Endif
				Endif
				If Vartype(.Record.Timestamp)='T'
					*  TimeStamp
					m.BackStamp=.Record.Timestamp
					.Record.Timestamp=Datetime()
				Endif
				m.rc=Recno()
				
				* !!!    
				
				If .MySave()		&&      
					Select (.Alias)
					If Between(m.rc,1,Reccount())
						Go (m.rc)
					Endif

					=WriteLog(.Record,iif(m.ThatNew,'CREATE','SAVE'))

					If Vartype(.Record.Timestamp)='T'
						.Record.Timestamp=Datetime()
					Endif

					Gather Name .Record
					
					*     
					*    MEMO     
					
					For i=1 To Fcount()
						If Type(Field(i))='M'
							c=Eval('.record.'+Field(i))
							If Not c==Eval(Fields(i))
								Replace (Field(i)) With (c)
							Endif
						Endif
					Next
					
					**** End Of Save *******************************
					
					If .EnumChilds("Save")
						If Not Commit_Transaction()
							*     - 
							.Fail=.T.
						Endif
					Else
						*      -   
						If Not RollBack_Transaction()
							* There currently - nothing
						Endif
						.Fail=.T.
					Endif
				Else
					If Not RollBack_Transaction()
						* There currently - nothing
					Endif
					.Fail=.T.
				Endif
				
				.Unlock()
				
				If .Fail
					Store m.BackKey To &s
					If Vartype(.Record.Timestamp)='T'
						Store m.BackStamp To .Record.Timestamp
					Endif
					.Errors.Show()
				Else
					.Changes=.F.
					.NewDocument=.F.
					.Saved=.T.
				Endif
				If Vartype(.Form)='O'
					.Form.Record=.Record
				Endif
				If Vartype(.ListForm)='O'
					.ListForm.Refresh
				Endif
			Endif
		Endif
		Return (Not .Fail)
	Endwith
	Endproc

	
	*--     
	*:********************************************************************
	*:
	*: Method : PREVIEW of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Preview
	This.Print(PRINT_PREVIEW)
	Endproc
	
	
	*--    
	*:********************************************************************
	*:
	*: Method : PRINTMODIFY of class DOCUMENT
	*:
	*:********************************************************************
	Procedure printmodify
	This.Print(PRINT_MODIFY)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : CHANGED of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Changed
	With This
		If Vartype(.Record)#'O'
			*** Don't set changes flag for not loaded record
			Return .Changes
		Endif
		Local m.key, m.Obj, m.cKey, m.Old, m.rc
		m.Old=Select()
		m.cKey=.KeyField
		m.key=GetPem(.Record,.KeyField)
		If Empty(m.key)
			Return .T.
		Endif
		Select (.Alias)
		m.rc=Recno()
		Locate For &cKey = m.key
		If !Found()
			Return .T.
		Endif
		Scatter Memo Name This.TestRecord
		.Changes=.Changes Or Not Compobj(.TestRecord,.Record)
		
		If Between(m.rc,1,Reccount())
			Go (m.rc)
		Endif
		Select (m.Old)
		Return .Changes
	Endwith
	Endproc
	
	
	*--   
	*:********************************************************************
	*:
	*: Method : LIST of class DOCUMENT
	*:
	*:********************************************************************
	Procedure List
	With This
		If Not .Grant(OP_LIST)
			Return .F.
		Endif
		
		If Vartype(.ListForm)=T_OBJECT
			.ListForm.Show
		Else
			Local o
			o=Newobject('MyView','VIEW.PRG')
			If Vartype(o)=T_OBJECT
				Select (.Alias)
				With o
					.ParentObject=This
					.CLSID=This.ListClsID
					.Alias=This.Alias
					.Caption=This.ListCaption
					.ReportForm=This.ListReportForm
					
					.Grid.RecordSource=This.Alias
					.Grid.RecordSourceType=1

					This.Grid(.Grid)

					Aspect(o)
					
					.Grid.ReadOnly=.T.
					.RestoreView()
					This.PostGrid(.Grid)
					
					.Resize
					.Show
				Endwith
				This.ListForm=o
			Endif
		Endif
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : GRID of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Grid
	* Init Grid Columns
	Lparameter oGrid
	Endproc
	
	*:********************************************************************
	*:
	*: Method : POSTGRID of class DOCUMENT
	*:
	*:********************************************************************
	Procedure PostGrid
	* After grid columns init
	Lparameter oGrid
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : CLOSE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Close
	With This
		If Vartype(.Form)='O'
			If .Form.Save(.T.)
				.Form.Release
			Else
				Return .F.
			Endif
		Else
			If Vartype(.ListForm)='O' and .ListForm.QueryUnLoad()
				.ListForm.Release
			Endif
		Endif
		Return .EnumChils('Close')
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : INIT of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Init
	With This
		If Not Empty(.Alias) And Not Used(.Alias)
			Messagebox(fString(MSG_NOTABLE,TableName(.Alias)),48,.Title)
			Return .F.
		Endif
		If  Type('.Parent')='O' ;
				and PEMStatus(.Parent,'REG',5) ;
				and .Child
			
			.Parent.Reg(This)
			
		Endif
		.ClassName=Upper(.Class)
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Destroy
	With This
		If Vartype(.Form)='O'
			.Form.Release
		Endif
		If Vartype(.ListForm)='O'
			If .ListForm.QueryUnload()
				.ListForm.Release
			EndIf 
		Endif
	Endwith
	DoDefault()
	Endproc
	
	
	*--  
	*:********************************************************************
	*:
	*: Method : PRINT of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Print( nAction )
	With This
		Local m.TopForm
		If Type('_screen.activeform')=T_OBJECT
			m.TopForm=_Screen.ActiveForm
			If Vartype(.ListForm)=T_OBJECT
				Local o
				o=Newobject("PRINTCLASS","CLASSES.PRG")
				If Vartype(o)=T_OBJECT
					o.FormFile=.ListReportForm
					o.Title=.ListForm.Caption
					o.Alias=.ListForm.Grid.RecordSource
					Return o.Print(nAction)
				Endif
				Return .F.
			Endif
		Endif
		*     
		If Not Empty(.ReportForm)
			If Vartype(.Record)#T_OBJECT
				If Not .Load()
					Return .F.
				Endif
			Endif
			Local o
			o=Newobject('PRINTCLASS','CLASSES.PRG')
			If Vartype(o)=T_OBJECT
				o.FormFile=.ReportForm
				o.Title=.Title
				o.Alias=.Alias
				o.Document=.Record
				
				Return o.Print(nAction)
				
			Endif
		Endif
	Endwith
	Endproc
	
	
	*--    
	*:********************************************************************
	*:
	*: Method : TESTED of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Tested
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : DEFAULT of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Default
	Endproc
	
	*:********************************************************************
	*:
	*: Method : MYSAVE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure MySave
	*   .F.   
	Endproc
	
	*:********************************************************************
	*:
	*: Method : MYDELETE of class DOCUMENT
	*:
	*:********************************************************************
	Procedure MyDelete
	*   .F.  
	Endproc
	
	*:********************************************************************
	*:
	*: Method : MYLOAD of class DOCUMENT
	*:
	*:********************************************************************
	Procedure MyLoad
	Endproc
	
	*:********************************************************************
	*:
	*: Method : SCRIPT of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Script( cEvent )
	Endproc
	
	*:********************************************************************
	*:
	*: Method : TRANSIENT_ASSIGN of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Transient_Assign( lVal )
	With This
		.Transient=lVal
		.CloseAliasOnDestroy=Not lVal
		.Modal=lVal
	Endwith
	
	*:********************************************************************
	*:
	*: Method : GRANT of class DOCUMENT
	*:
	*:********************************************************************
	Procedure Grant( m.Action)
	With This
		If Admin()
			Return .T.
		Endif
		If Not Used("Grant")
			Return .F.
		Endif
		Select Mask From Grant Where Object=ChkVal(.ClassName) And Group=ChkVal(_UserGroup) Into Array tmp
		If _Tally=0
			Return .F.
		Endif
		Do Case
		Case m.Action=OP_NEW
			Return Bittest(tmp[1],MASK_NEW)
		Case m.Action=OP_OPEN
			Return Bittest(tmp[1],MASK_OPEN)
		Case m.Action=OP_DELETE
			Return Bittest(tmp[1],MASK_DELETE)
		Case m.Action=OP_LIST
			Return Bittest(tmp[1],MASK_LIST)
		Endcase
		Return .F.
	Endwith

	*        

	Procedure GetCustomer	&&  
	
	Procedure GetData		&&   
	
	Procedure GetDate		&&   
	
	Procedure GetNumber		&&   
	
	Procedure GetOwner		&&  

	Procedure GetOption		&&    
	
	
Enddefine

*:********************************************************************
*:
*:    Class : CONTENTS based on BASECLASS
*:
*:********************************************************************
Define Class Contents As BaseClass
	
	Comment="      "
	Alias=""		&&    CONTENTS
	TmpAlias=""		&&       CONTENTS
	Title=""		&&  ?
	ViewForm=.Null.
	KeyField=""		&&     
	Changes=.F.		&&    
	Grant=0

	ThisDoc=.null.

	ProgressBar=.null.
	
	*:********************************************************************
	*:
	*: Method : INIT of class CONTENTS
	*:
	*:********************************************************************
	Procedure Init
	With This
		If Type('.PARENT')#'O'
			Messagebox("     .",16,"")
			Return .F.
		Endif
		.ThisDoc=.Parent
		Return .CreateTmpFile() And DoDefault()
	Endwith
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class CONTENTS
	*:
	*:********************************************************************
	Procedure Destroy
	With This
		If Used(.TmpAlias)
			Use In (.TmpAlias)
		Endif
		.CloseAliasOnDestroy=.Parent.CloseAliasOnDestroy
		DoDefault()
	Endwith
	
	*:********************************************************************
	*:
	*: Method : DELETE of class CONTENTS
	*:
	*:********************************************************************
	Procedure Delete
	*  
	With This
		If Not Used(.Alias)
			.ThisDoc.Errors.Add("   .")
			Return .F.
		Endif
		
		Local m.DocID
		m.DocID=.Parent.Record.DocID
		
		*      
		Select (.Alias)
		Scan All For DocID=m.DocID
			Scatter Memo Name .Record
			If Not .EnumChilds('Delete')
				Return .F.
			Endif
		Endscan
		
		*  -     - L -   
		
		If Type(.Alias+'.DELETED')='L'
			Replace Deleted With .T. All For DocID=m.DocID
		Else
			Delete All For DocID=m.DocID
		Endif
		
		Select (.Parent.Alias)
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : LOAD of class CONTENTS
	*:
	*:********************************************************************
	Procedure Load
	**  
	With This
		Local m.DocID, m.rc, m.nAll, m.nCurrent

		If Not .DataUsed()
			Return .F.
		Endif
		Zap In (.TmpAlias)

		m.DocID=.Parent.Record.DocID	&&   

		.Comment=_VFP.StatusBar
		_VFP.StatusBar="  ..."

		.ProgressBar=NewObject("VFPBar","Commctrl.Prg")
		.ProgressBar.Show()

		Select Count(*) from (.Alias) where docid=m.docid into array tmp
		m.nAll=TMP[1]
		m.nCurrent=0
		
		Select (.Alias)
		Scan All For DocID=m.DocID
			m.nCurrent = m.nCurrent + 1 
			.Process(m.nCurrent,m.nAll)

			Scatter Memo Name .Record	&&     BatchAlias  TmpAlias
			Select (.TmpAlias)
			Append Blank
			Gather Memo Name .Record	&&   
			Scatter Memo Name .Record	&&   .Record   .TmpAlias
			m.rc=Recno(.TmpAlias)
			If Not .EnumChilds("Load")
				Return .F.
			Endif
			Select (.TmpAlias)
			Go (m.rc)
			Gather Memo Name .Record	&&   .TmpAlias  EnumChilds
			Select (.Alias)
		Endscan
		.Abort()
	Endwith
	
	*:********************************************************************
	*:
	*: Method : SAVE of class CONTENTS
	*:
	*:********************************************************************
	Procedure Save
	**  
	With This
		If Not .DataUsed()
			Return .F.
		Endif
		
		.Comment=_VFP.StatusBar
		_VFP.StatusBar="  ..."

		.ProgressBar=NewObject("VFPBar","Commctrl.Prg")
		.ProgressBar.Show()
		
		Local m.DocID, m.rc, tmp[1], m.nAll, m.nCurrent
		m.DocID=.Parent.Record.DocID

		Select Count(*) from (.Alias) where docid=m.docid into array tmp
		m.nAll=TMP[1]

		Select Count(*) from (.TmpAlias) into array tmp
		m.nAll=m.nAll+TMP[1]
		
		*         

		m.nCurrent=0
		
		Select (.Alias)
		Scan All For DocID=m.DocID
			m.nCurrent = m.nCurrent + 1 
			m.rc=Recno()
			Scatter Memo Name .Record
			If Not .EnumChilds('Retrieve')
				Return .Abort()
			Endif
			.Process(m.nCurrent,m.nAll)
			Select (.Alias)
			Go (m.rc)
		Endscan
		
		*   
		
		If Type(.Alias+'.DELETED')='L'
			Replace Deleted With .T. All For DocID=m.DocID
		Else
			Blank All For DocID=m.DocID
		Endif
		
		*     
		
		Select (.TmpAlias)
		Scan All
			m.nCurrent = m.nCurrent + 1 
			Scatter Memo Name .Record
			.Record.DocID=.Parent.Record.DocID
			
			Select (.Alias)
			Locate For Empty(DocID)
			If Not Found()
				Append Blank
			Endif
			Gather Memo Name .Record
			m.rc=Recno()
			
			If Not .EnumChilds("Save")
				Return .Abort()
			Endif
			Go m.rc
			
			Gather Memo Name .Record

			.Process(m.nCurrent,m.nAll)
		
			Select (.TmpAlias)
		Endscan

		.Abort()

	Endwith
	
	.Changes=.F.
	
	*:********************************************************************
	*:
	*: Method : CREATE of class CONTENTS
	*:
	*:********************************************************************
	Procedure Create
	**   
	With This
		
		If Not .DataUsed()
			Return .F.
		Endif
		If Not .EnumChilds('Create')
			Return .F.
		Endif
		.Record=.Null.
		Zap In (.TmpAlias)
		.Changes=.F.
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : CHANGED of class CONTENTS
	*:
	*:********************************************************************
	Procedure Changed
	*       
	Return This.Changes
	
	*:********************************************************************
	*:
	*: Method : DATAUSED of class CONTENTS
	*:
	*:********************************************************************
	Procedure DataUsed
	With This
		If Not Used(.Alias)
			.ThisDoc.Errors.Add("   .")
			Return .F.
		Endif
		If Not Used(.TmpAlias)
			If Not .CreateTmpFile()
				.ThisDoc.Errors.Add("    .")
				Return .F.
			Endif
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : CREATETMPFILE of class CONTENTS
	*:
	*:********************************************************************
	Procedure CreateTmpFile( m.cAlias )
	With This
		If Empty(m.cAlias)
			m.cAlias=Sys(2015)
		Endif
		If Used(.Alias)
			Local tmp[1],nCountFields
			m.nCountFields=Afields(tmp,.Alias)
			If m.nCountFields > 0
				
				Create Cursor (m.cAlias) From Array tmp
				
				If .AlterTable(m.cAlias)
					.TmpAlias=m.cAlias
					Return .T.
				Endif
				
			Endif
		Endif
		.TmpAlias=""
	Endwith
	Return .F.
	
	*:********************************************************************
	*:
	*: Method : ALTERTABLE of class CONTENTS
	*:
	*:********************************************************************
	Procedure AlterTable( m.cAlias )
	*        
	*      
	*       .F.   CreateTMPFile
	*    .F.


	*  API 
	Procedure Add(m.ItemID, m.Batch, m.Price, m.Amount,m.Amount2)
	
	Procedure Update(m.ItemID, m.Batch, m.Price, m.Amount,m.Amount2)
	
	Procedure Remove(m.ItemId, m.Batch)

	Procedure Process(m.nCurrent,m.nAll)
	With this
		.progressBar.value(m.nCurrent/m.nAll)
	EndWith

	Procedure Abort
	With this
		.ProgressBar=.null.
		_VFP.StatusBar=.Comment
		Return .F.
	EndWith

	
Enddefine


Define Class Errors as BaseClass
	Title="  "
	ErrsCount=0
	
	Dimension Errs[1]
	
	Procedure Add(m.cText)
	With this
		.ErrsCount=.ErrsCount+1
		Dimension .Errs[.ErrsCount]
		.Errs[.ErrsCount]=m.cText
	EndWith
	
	Procedure Clear()
	With this
		Dimension Errs[1]
		.ErrsCount=0
	EndWith
	
	Procedure Show
	With this
		If .ErrsCount > 0
			Local o, i, s
			o=ErrorMSG()
			With o
				s=""
				For i=1 to this.ErrsCount
					s=s+This.Errs[i]+CRLF
				Next				
				.Text.Value=s
				.Show(1)
			EndWith
		EndIf
	EndWith

EndDefine 



*:********************************************************************
*:
*:    Class : BASECLASS based on CUSTOM
*:
*:********************************************************************
Define Class BaseClass As Custom
	CloseAliasOnDestroy=.T.
	Transient=.F.	&& CloseAliasOnDestroy=.F. and Modal=.T.
	
	Alias=""
	Title=""
	CLSID=""
	Record=.Null.
	Dimension Childs[1]
	Child=.T.
	ErrorText=""
	ErrorCaption=""
	ClassName=""
	
	*:********************************************************************
	*:
	*: Method : TRANSIENT_ASSIGN of class BASECLASS
	*:
	*:********************************************************************
	Procedure Transient_Assign( lVal )
	With This
		.Transient=lVal
		.CloseAliasOnDestroy=Not lVal
	Endwith
	
	
	*:********************************************************************
	*:
	*: Method : INIT of class BASECLASS
	*:
	*:********************************************************************
	Procedure Init
	With This
		If Type('.Parent')='O' ;
				and PEMStatus(.Parent,'REG',5) ;
				and .Child
			
			If .Parent.Reg(This)
				*				.CloseAliasOnDestroy=.T.
			Endif
		Endif
		.ClassName=Upper(.Class)
	Endwith
	
	*:********************************************************************
	*:
	*: Method : REG of class BASECLASS
	*:
	*:********************************************************************
	Procedure Reg
	**   
	Lparameter m.oChild
	With This
		If Vartype(m.oChild)='O' And m.oChild.Child
			Local k
			k=Alen(.Childs,1)+1
			Dimension .Childs[k]
			.Childs[k]=m.oChild
			Return .T.
		Endif
		Return .F.
	Endwith
	
	*:********************************************************************
	*:
	*: Method : ENUMCHILDS of class BASECLASS
	*:
	*:********************************************************************
	Procedure EnumChilds
	**   
	Lparameter m.cMethod, m.cParamString
	If Empty(m.cParamString)
		m.cParamString=""
	Endif
	Local o, m.lRet, m.cProc
	m.cProc=Alltrim(Getwordnum(m.cMethod,1,'(['))
	m.lRet=.T.
	For Each o In This.Childs
		If Vartype(o)='O' And PEMStatus(o,m.cProc,5)
			If m.cProc=m.cMethod
				m.cMethod=m.cMethod+"()"
			Endif
			m.lRet=m.lRet And Eval('o.'+m.cMethod)
		Endif
	Next
	Return m.lRet
	
	*:********************************************************************
	*:
	*: Method : LOCK of class BASECLASS
	*:
	*:********************************************************************
	Procedure Lock
	With This
		If Used(.Alias)
			If Flock(.Alias)
				If Not .EnumChilds("Lock")
					Unlock In (.Alias)
					Return .F.
				Endif
			Else
				* If Lock failed ...
				Local m.DBFTitle
				m.DBFTitle=TableName(.Alias)
				Messagebox(fString(MSG_LOCKFAIL,m.DBFTitle),16,.Title)
				Return .F.
			Endif
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : UNLOCK of class BASECLASS
	*:
	*:********************************************************************
	Procedure Unlock
	With This
		If Used(.Alias)
			Unlock In (.Alias)
			.EnumChilds("UnLock")
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : CLOSE of class BASECLASS
	*:
	*:********************************************************************
	Procedure Close
	With This
		Use In Select(.Alias)
		.EnumChilds('Close')
	Endwith
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class BASECLASS
	*:
	*:********************************************************************
	Procedure Destroy
	With This
		Store .Null. To .Childs
		If .CloseAliasOnDestroy And Used(.Alias)
			Use In (.Alias)
		Endif
	Endwith
Enddefine

*: End of DOCUMENT.PRG
