
#define WM_USER             0x0400
#define _WIN32              0x0400
#define WINVER              0x0400
#define UNICODE				.F.

*
* Window Styles
*


#define WS_OVERLAPPED       0x00000000
#define WS_POPUP            0x80000000
#define WS_CHILD            0x40000000
#define WS_MINIMIZE         0x20000000
#define WS_VISIBLE          0x10000000
#define WS_DISABLED         0x08000000
#define WS_CLIPSIBLINGS     0x04000000
#define WS_CLIPCHILDREN     0x02000000
#define WS_MAXIMIZE         0x01000000
#define WS_CAPTION          0x00C00000
#define WS_BORDER           0x00800000
#define WS_DLGFRAME         0x00400000
#define WS_VSCROLL          0x00200000
#define WS_HSCROLL          0x00100000
#define WS_SYSMENU          0x00080000
#define WS_THICKFRAME       0x00040000
#define WS_GROUP            0x00020000
#define WS_TABSTOP          0x00010000

*--	/*
*--	 * Extended Window Styles
*--	 */
#define WS_EX_DLGMODALFRAME     0x00000001
#define WS_EX_NOPARENTNOTIFY    0x00000004
#define WS_EX_TOPMOST           0x00000008
#define WS_EX_ACCEPTFILES       0x00000010
#define WS_EX_TRANSPARENT       0x00000020
*--	#if(WINVER >= 0x0400)
#define WS_EX_MDICHILD          0x00000040
#define WS_EX_TOOLWINDOW        0x00000080
#define WS_EX_WINDOWEDGE        0x00000100
#define WS_EX_CLIENTEDGE        0x00000200
#define WS_EX_CONTEXTHELP       0x00000400

#define WS_EX_RIGHT             0x00001000
#define WS_EX_LEFT              0x00000000
#define WS_EX_RTLREADING        0x00002000
#define WS_EX_LTRREADING        0x00000000
#define WS_EX_LEFTSCROLLBAR     0x00004000
#define WS_EX_RIGHTSCROLLBAR    0x00000000

#define WS_EX_CONTROLPARENT     0x00010000
#define WS_EX_STATICEDGE        0x00020000
#define WS_EX_APPWINDOW         0x00040000


*--	#define WS_EX_OVERLAPPEDWINDOW  (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE)
*--	#define WS_EX_PALETTEWINDOW     (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST)

*
* 
*



*
* Window field offsets for GetWindowLong()
*

#define GWL_WNDPROC         (-4)
#define GWL_HINSTANCE       (-6)
#define GWL_HWNDPARENT      (-8)
#define GWL_ID              (-12)
#define GWL_STYLE           (-16)
#define GWL_EXSTYLE         (-20)
#define GWL_USERDATA        (-21)


*
* Class field offsets for GetClassLong()
*

#define GCL_MENUNAME        (-8)
#define GCL_HBRBACKGROUND   (-10)
#define GCL_HCURSOR         (-12)
#define GCL_HICON           (-14)
#define GCL_HMODULE         (-16)
#define GCL_CBWNDEXTRA      (-18)
#define GCL_CBCLSEXTRA      (-20)
#define GCL_WNDPROC         (-24)
#define GCL_STYLE           (-26)
#define GCW_ATOM            (-32)

#define CW_USEDEFAULT       (-1)	&&((int)0x80000000)

*-- LoadLibraryEx parameters

#define DONT_RESOLVE_DLL_REFERENCES     0x00000001
#define LOAD_LIBRARY_AS_DATAFILE        0x00000002
#define LOAD_WITH_ALTERED_SEARCH_PATH   0x00000008


#define CCM_FIRST               0x2000      &&	// Common control shared messages

#define CCM_SETBKCOLOR          (CCM_FIRST + 1) &&	// lParam is bkColor


*//====== PROGRESS CONTROL =====================================================

#define PROGRESS_CLASS		"msctls_progress32"

#define PBS_SMOOTH			0x01
#define PBS_VERTICAL		0x04

#define PBM_SETRANGE		(WM_USER+1)
#define PBM_SETPOS			(WM_USER+2)
#define PBM_DELTAPOS		(WM_USER+3)
#define PBM_SETSTEP			(WM_USER+4)
#define PBM_STEPIT			(WM_USER+5)

#define PBM_SETRANGE32		(WM_USER+6)	&& // lParam = high, wParam = low
#define PBM_GETRANGE		(WM_USER+7)	&& // wParam = return (TRUE ? low : high). lParam = PPBRANGE or NULL
#define PBM_GETPOS			(WM_USER+8)

#define PBM_SETBARCOLOR		(WM_USER+9)	&& // lParam = bar color
#define PBM_SETBKCOLOR		CCM_SETBKCOLOR	&& // lParam = bkColor


*//====== ANIMATE CONTROL ======================================================

#define ANIMATE_CLASS		"SysAnimate32"

*!*	// begin_r_commctrl

#define ACS_CENTER			0x0001
#define ACS_TRANSPARENT		0x0002
#define ACS_AUTOPLAY		0x0004

*!*	#if (_WIN32_IE >= 0x0300)
#define ACS_TIMER               0x0008  && don't use threads... use timers
*!*	#endif

*!*	// end_r_commctrl

#define ACM_OPENA			(WM_USER+100)

#define ACM_OPENW			(WM_USER+103)

#if	UNICODE
#define ACM_OPEN			ACM_OPENW
#else
#define ACM_OPEN			ACM_OPENA
#endif

#define ACM_PLAY			(WM_USER+101)
#define ACM_STOP			(WM_USER+102)

#define ACN_START			1
#define ACN_STOP			2

#define	AC_SYS_SEARCH		150
#define	AC_SYS_FINDFILE		151
#define	AC_SYS_FINDCOMP		152
#define	AC_SYS_FILEMOVE		160
#define	AC_SYS_FILECOPY		161
#define	AC_SYS_FILEDEL		162
#define	AC_SYS_FILENUKE		163
#define	AC_SYS_FILEDELR		164


*//=============================================================================

#define OF_READ			0x00000000
#define OF_WRITE		0x00000001
#define OF_READWRITE		0x00000002
#define OF_SHARE_COMPAT		0x00000000
#define OF_SHARE_EXCLUSIVE	0x00000010
#define OF_SHARE_DENY_WRITE	0x00000020
#define OF_SHARE_DENY_READ	0x00000030
#define OF_SHARE_DENY_NONE	0x00000040
#define OF_PARSE		0x00000100
#define OF_DELETE		0x00000200
#define OF_VERIFY		0x00000400
#define OF_CANCEL		0x00000800
#define OF_CREATE		0x00001000
#define OF_PROMPT		0x00002000
#define OF_EXIST		0x00004000
#define OF_REOPEN		0x00008000

#define OFS_MAXPATHNAME		128

#define _OFSTRUCT		(Chr(136)+Repl(Chr(0),136))

*--	
*--	typedef struct _OFSTRUCT {
*--	    BYTE cBytes;
*--	    BYTE fFixedDisk;
*--	    WORD nErrCode;
*--	    WORD Reserved1;
*--	    WORD Reserved2;
*--	    CHAR szPathName[OFS_MAXPATHNAME];
*--	} OFSTRUCT, *LPOFSTRUCT, *POFSTRUCT;
*--	


*--//----------------------------------------------------------------------------
*--//
*--//   ObjToClient constants
*--//
*--//----------------------------------------------------------------------------

#define OTC_TOP				1
#define OTC_LEFT			2
#define OTC_WIDTH			3
#define OTC_HEIGHT			4

