*:********************************************************************
*:
*: Procedure file :config.prg
*:
*: (c) Piva, BEAR v.43 on 13.05.2003 13:44
*:********************************************************************
*
*      
*   .. 1999-2003
*

#include Include\Main.h

#Define OBJTYPE_WINDOW		1
#Define OBJTYPE_GRID		2
#Define OBJTYPE_LISTVIEW	3
#Define OBJTYPE_RECORD		4
#Define OBJTYPE_SPLITBAR	5
#Define OBJTYPE_TOOLBAR		6
#Define OBJTYPE_QUERY		7

*:********************************************************************
*:
*: Procedure : GetLocalProfile
*:
*:********************************************************************
Procedure GetLocalProfile( m.cSection, m.cEntry, m.xDefault )
Return Profile(m.cSection, m.cEntry, m.xDefault)

*:********************************************************************
*:
*: Procedure : GetLocalSection
*:
*:********************************************************************
Procedure GetLocalSection( aSections, m.cSection )
Return ProfileSection(@aSections,m.cSection)

*:********************************************************************
*:
*: Procedure : SetLocalProfile
*:
*:********************************************************************
Procedure SetLocalProfile( m.cSection, m.cEntry, m.xDefault )
Return PutProfile(m.cSection, m.cEntry, m.xDefault)

***************** Global config access ******************

*:********************************************************************
*:
*: Procedure : GetGlobalProfile
*:
*:********************************************************************
Procedure GetGlobalProfile( m.cSection, m.cEntry, m.xDefault )
Return Profile(m.cSection, m.cEntry, m.xDefault, _TABLES+BOOT_INF)

*:********************************************************************
*:
*: Procedure : GetGlobalSection
*:
*:********************************************************************
Procedure GetGlobalSection( aSections, m.cSection )
Return ProfileSection(@aSections,m.cSection,_TABLES+BOOT_INF)

*:********************************************************************
*:
*: Procedure : SetGlobalProfile
*:
*:********************************************************************
Procedure SetGlobalProfile( m.cSection, m.cEntry, m.xDefault )
Return PutProfile(m.cSection, m.cEntry, m.xDefault, _TABLES+BOOT_INF)

*:********************************************************************
*:
*: Procedure : GetBootValue
*:
*:********************************************************************
Procedure GetBootValue(m.cSection, m.cEntry, m.xDefault)
Return GetGlobalProfile(m.cSection, m.cEntry, m.xDefault)

*:********************************************************************
*:
*: Procedure : SetBootValue
*:
*:********************************************************************
Procedure SetBootValue(m.cSection, m.cEntry, m.xDefault)
Return SetGlobalProfile(m.cSection, m.cEntry, m.xDefault)

*:********************************************************************
*:
*: Procedure : SaveWindowPref
*:
*:********************************************************************
Procedure SaveWindowPref( m.oForm, m.nSplitPos )
*     CONFIG.DAT     UserID
*        , 
*      
*   UserID  Fox , .. 
* -      -  ? (    )
If Used('CONFIG') and not IsReadOnly("CONFIG")
	With oForm
		
		Local m.old, m.CLSID, m.nPos
		m.nPos=Iif(Vartype(m.nSplitPos)='N',m.nSplitPos,0)
		m.old=Select()
		If Vartype(.CLSID)='C' And Not Empty(.CLSID)
			m.CLSID=Padr(.CLSID,Fsize('CLSID','CONFIG'))
		Else
			m.CLSID=Padr(.Comment,Fsize('CLSID','CONFIG'))
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid=_UserID And CLSID=m.CLSID And ObjType=OBJTYPE_WINDOW
		If Not Found()
			Append Blank
			Go Recno()
			Replace ;
				UserID	With _UserID;
				,CLSID		With m.CLSID;
				,ObjType	With OBJTYPE_WINDOW
		Endif
		If .WindowState=1
			Replace State With .WindowState
		Else
			If Vartype(.ForceNormalView)='L' ;
					and .ForceNormalView ;
					and .WindowState # 0
				
				Replace ;
					State	With .WindowState
				
			Else
				Replace ;
					Top	With .Top;
					,Left	With .Left;
					,Height	With .Height;
					,Width	With .Width; 
					,State	With .WindowState
			Endif
			Replace Index With nPos
		Endif
		
		Go Recno()
		Select (m.old)
		
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : ReadWindowPref
*:
*:********************************************************************
Procedure ReadWindowPref( m.oForm, m.nSplitPos )
If Used("CONFIG") 
	With oForm
		Local m.old, m.CLSID
		m.old=Select()
		If Vartype(.CLSID)='C' And Not Empty(.CLSID)
			m.CLSID=Padr(.CLSID,Fsize('CLSID','CONFIG'))
		Else
			m.CLSID=Padr(.Comment,Fsize('CLSID','CONFIG'))
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid= _UserID And CLSID=m.CLSID And ObjType=OBJTYPE_WINDOW
		If Found()
			.Top=Top
			.Left=Left
			m.nSplitPos=Index
			If .BorderStyle = 3
				.Height=Height
				.Width=Width
				If Vartype(.ForceNormalView)='L' And .ForceNormalView=.T.
					.WindowState=0
				Else
					.WindowState=State
				Endif
			Endif
		Endif
		Select (m.old)
	Endwith
Endif


*:********************************************************************
*:
*: Procedure : SaveListPref
*:
*:********************************************************************
Procedure SaveListPref( m.oList )
If Used('CONFIG') and not IsReadOnly("CONFIG")
	With oList
		Local m.old, m.CLSID, i
		m.old=Select()
		If Vartype(.CLSID)='C' And Not Empty(.CLSID)
			m.CLSID=.CLSID
		Else
			If Vartype(.Parent.CLSID)='C' ;
					and Not Empty(.Parent.CLSID)
				m.CLSID=Padr(.Parent.CLSID,Fsize('CLSID','CONFIG'))
			Else
				m.CLSID=.Comment
			Endif
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		
		Do Case
		Case .BaseClass='Grid'				&& Grid in form
			For i=1 To .ColumnCount
				Locate 	For Userid=_UserID ;
					and CLSID=m.CLSID ;
					and ObjType=OBJTYPE_GRID ;
					and Index = i
				
				If Not Found()
					Append Blank
					Go Recno()
					Replace ;
						UserID	With _UserID;
						,CLSID		With m.CLSID;
						,ObjType	With OBJTYPE_GRID ;
						,Index		With i
					
				Endif
				Replace ;
					Order 		With .Columns[i].ColumnOrder;
					,Width		With .Columns[i].Width/_ASPECT;
					,Hide		With Not .Columns[i].Visible;
					,State		With .Columns[i].SearchStyle

			Next
			
			Locate 	For Userid=_UserID ;
				and CLSID=m.CLSID ;
				and ObjType=OBJTYPE_RECORD
			
			If Not Found()
				Append Blank
				Go Recno()
				Replace ;
					UserID	With _UserID;
					,CLSID		With m.CLSID;
					,ObjType	With OBJTYPE_RECORD ;
					
			Endif
			If Used(.RecordSource)
				Replace Index With Recno(.RecordSource)
			Endif
			
		Case .BaseClass='OleControl'		&& Caused as ListView (may be )
			For i=1 To .ColumnHeaders.Count
				Locate 	For Userid=_UserID ;
					and CLSID=m.CLSID ;
					and ObjType=OBJTYPE_LISTVIEW ;
					and Index = i
				
				If Not Found()
					Append Blank
					Go Recno()
					Replace ;
						UserID	With _UserID;
						,CLSID		With m.CLSID;
						,ObjType	With OBJTYPE_LISTVIEW ;
						,Index		With i
					
				Endif
				Replace ;
					Order 		With .ColumnHeader[i].Position;
					,Width		With .ColumnHeader[i].Width/_ASPECT
				
				
			Next
		Endcase
		Select (m.old)
	Endwith
Endif


*:********************************************************************
*:
*: Procedure : ReadListPref
*:
*:********************************************************************
Procedure ReadListPref( m.oList )
If Used('CONFIG')
	With oList
		Local m.old, m.CLSID, i
		m.old=Select()
		
		If Vartype(.CLSID)='C';
				and Not Empty(.CLSID)
			m.CLSID=.CLSID
		Else
			If Vartype(.Parent.CLSID)='C' ;
					and Not Empty(.Parent.CLSID)
				m.CLSID=Padr(.Parent.CLSID,Fsize('CLSID','CONFIG'))
			Else
				m.CLSID=.Comment
			Endif
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		
		Do Case
		Case .BaseClass='Grid'				&& Grid in form
			For i=1 To .ColumnCount

				Locate 	For Userid=_UserID ;
					and CLSID=m.CLSID ;
					and ObjType=OBJTYPE_GRID ;
					and Index = i
				
				If Found()
					.Columns[i].ColumnOrder=Order
					.Columns[i].Width=Width*_ASPECT
					.Columns[i].Visible=Not Hide
					.Columns[i].SearchStyle=State
					
					If Not .Columns[i].Visible
						.Columns[i].Width=0
						.Columns[i].Resizable=.F.
					Endif
				Endif
			Next
			Locate 	For Userid=_UserID ;
				and CLSID=m.CLSID ;
				and ObjType=OBJTYPE_RECORD
			
			If Found()
				If Used(.RecordSource) And Between(Index,1,Reccount(.RecordSource))
					Go (CONFIG.Index) In (.RecordSource)
				Endif
			Endif
			
		Case .BaseClass='OleControl'		&& Caused as ListView (may be )
			For i=1 To .ColumnHeaders.Count
				Locate 	For Userid=_UserID ;
					and CLSID=m.CLSID ;
					and ObjType=OBJTYPE_LISTVIEW ;
					and Index = i
				
				If Found()
					.ColumnHeader[i].Position=Order
					.ColumnHeader[i].Width=Width*_ASPECT
				Endif
			Next
		Endcase
		Select (m.old)
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : SaveToolBarPref
*:
*:********************************************************************
Procedure SaveToolBarPref( oToolBar )
If Used("CONFIG") and Not ISREADONLY("CONFIG")
	With oToolBar
		Local m.old, m.CLSID, m.nPos
		m.nPos=Iif(Vartype(m.nSplitPos)='N',m.nSplitPos,0)
		m.old=Select()
		If Vartype(.CLSID)='C' And Not Empty(.CLSID)
			m.CLSID=Padr(.CLSID,Fsize('CLSID','CONFIG'))
		Else
			m.CLSID=Padr(.Comment,Fsize('CLSID','CONFIG'))
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid=_UserID And CLSID=m.CLSID And ObjType=OBJTYPE_TOOLBAR
		If Not Found()
			Append Blank
			Go Recno()
			Replace ;
				UserID	With _UserID;
				,CLSID		With m.CLSID;
				,ObjType	With OBJTYPE_TOOLBAR
		Endif
		Replace ;
			Top	With .Top;
			,Left	With .Left;
			,Index	With .DockPosition;
			,Logical With .Docked;
			,Hide	With Not .Visible
		
		
		Go Recno()
		
		Select (m.old)
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : ReadToolBarPref
*:
*:********************************************************************
Procedure ReadToolBarPref( oToolBar)
If Used("CONFIG")
	With oToolBar
		Local m.old, m.CLSID
		m.old=Select()
		If Vartype(.CLSID)='C' And Not Empty(.CLSID)
			m.CLSID=Padr(.CLSID,Fsize('CLSID','CONFIG'))
		Else
			m.CLSID=Padr(.Comment,Fsize('CLSID','CONFIG'))
		Endif
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid= _UserID And CLSID=m.CLSID And ObjType=OBJTYPE_TOOLBAR
		If Found()
			.Top=Top
			.Left=Left
			.DockState=Logical
			.Position=Index
			.Shown=Not Hide
			
		Endif
		Select (m.old)
	Endwith
Endif


*:********************************************************************
*:
*: Procedure : SaveQueryPref
*:
*:********************************************************************
Procedure SaveQueryPref( cName, oParm )
If Used("CONFIG") and not ISREADONLY("CONFIG")
	With oParm
		Local m.old, m.CLSID, m.nPos
		m.old=Select()
		m.CLSID=cName
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid=_UserID And CLSID=m.CLSID And ObjType=OBJTYPE_QUERY
		If Not Found()
			Append Blank
			Go Recno()
			Replace ;
				UserID		With _UserID;
				,CLSID		With m.CLSID;
				,ObjType	With OBJTYPE_QUERY
		Endif
		Replace ;
			DateMin			With .DateMin;
			,DateMax		With .DateMax;
			,OwnerID		With .OwnerID;
			,CustID			With .CustID;
			,GroupID		With .GroupID;
			,ItemID			With .ItemID;
			
		
		Select (m.old)
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : ReadQueryPref
*:
*:********************************************************************
Procedure ReadQueryPref( cName, oParm )
If Used("CONFIG")
	With oParm
		Local m.old, m.CLSID, m.nPos
		m.old=Select()
		m.CLSID=cName
		If Empty(m.CLSID)
			Return .F.
		Endif
		
		Select CONFIG
		Locate For Userid=_UserID And CLSID=m.CLSID And ObjType=OBJTYPE_QUERY
		If Found()
			.DateMin=DateMin
			.DateMax=DateMax
			.OwnerID=OwnerID
			.CustID=CustID
			.GroupID=GroupID
			.ItemID=ItemID
		Endif
		Select (m.old)
	Endwith
Endif

***    CONFIG ****
***         
***    -   -     

*:********************************************************************
*:
*: Procedure : LocalSet
*:
*:********************************************************************
Procedure LocalSet( cVarName, xValue, cTypeForce, m.cUser )
If Used('CONFIG') and not IsReadOnly("CONFIG")
	Local m.old, m.CLSID, m.UserID
	m.old=Select()
	
	m.CLSID=Padr(cVarName,Fsize('CLSID','CONFIG'))
	
	If Not Empty(m.cUser) And Vartype(m.cUser)='C'
		m.UserID=m.cUser
	Else
		m.UserID=Padr(_UserID,Fsize('UserID','CONFIG'))
	Endif
	
	If !Empty(cTypeForce) And Vartype(cTypeForce)='C'
		m.type=cTypeForce
	Else
		m.type=Vartype(xValue)
	Endif
	m.old=Select()
	
	Select CONFIG
	Locate For Userid=m.UserID And CLSID=m.CLSID
	If Not Found()
		Insert Into CONFIG ( Userid, CLSID ) ;
			values (m.UserID, m.CLSID )
	Endif
	Replace Type With m.type
	Do Case
	Case m.type='N'
		If Mod(xValue,1)=0
			m.type='I'
			Replace Type With 'I',Integer With xValue
		Else
			Replace Number With xValue
		Endif
	Case m.type='C'
		Replace Text With xValue
	Case m.type='L'
		Replace Logical With xValue
	Case m.type='D'
		Replace Date With xValue
	Case m.type='T'
		Replace Datetime With xValue
	Case m.type='Y'
		Replace Currency With xValue
	Other
		* none
	Endcase
	Replace Timestamp With Datetime()
	Go Recno()
	Select (m.old)
Endif

*:********************************************************************
*:
*: Procedure : LocalGet
*:
*:********************************************************************
Procedure LocalGet( cVarName, xDefault, m.cUser )
If Used('CONFIG')
	Local m.old, m.CLSID, m.UserID
	m.old=Select()
	m.CLSID=Padr(cVarName,Fsize('CLSID','CONFIG'))
	
	If Not Empty(m.cUser) And Vartype(m.cUser)='C'
		m.UserID=m.cUser
	Else
		m.UserID=Padr(_UserID,Fsize('UserID','CONFIG'))
	Endif
	
	Select CONFIG
	Locate For Userid=m.UserID And CLSID=m.CLSID
	If Found()
		Do Case
		Case Type='I'
			xDefault=Integer
		Case Type='N'
			xDefault=Mton(Number)
		Case Type='Y'
			xDefault=Currency
		Case Type='L'
			xDefault=Logical
		Case Type='D'
			xDefault=Date
		Case Type='T'
			xDefault=Datetime
		Case Type='C'
			xDefault=Alltrim(Text)
		Endcase
	Endif
	Select (m.old)
Endif
Return xDefault

*:********************************************************************
*:
*: Procedure : GlobalSet
*:
*:********************************************************************
Procedure GlobalSet(cVarName, vValue, cTypeForce)
Return LocalSet(cVarName, vValue, "",'**Global**')

*:********************************************************************
*:
*: Procedure : GlobalGet
*:
*:********************************************************************
Procedure GlobalGet( cVarName, xDefault )
Return LocalGet(cVarName, xDefault, '**Global**')

*:********************************************************************
*:
*: Procedure : DateLocalSet
*:
*:********************************************************************
Procedure DateLocalSet( tDate, cVarName, xValue, cTypeForce, m.cUser )
If Used('CONFIG') and not IsReadOnly("CONFIG")
	Local m.old, m.CLSID, m.UserID
	m.old=Select()
	
	m.CLSID=Padr(cVarName,Fsize('CLSID','CONFIG'))
	
	If Not Empty(m.cUser) And Vartype(m.cUser)='C'
		m.UserID=m.cUser
	Else
		m.UserID=Padr(_UserID,Fsize('UserID','CONFIG'))
	Endif
	
	If !Empty(cTypeForce) And Vartype(cTypeForce)='C'
		m.type=cTypeForce
	Else
		m.type=Vartype(xValue)
	Endif
	m.old=Select()
	
	Select CONFIG
	Locate For Userid=m.UserID And CLSID=m.CLSID And Datetime=m.tDate
	If Not Found()
		Insert Into CONFIG ( Userid, CLSID ) ;
			values (m.UserID, m.CLSID )
	Endif
	Replace Type With m.type
	Do Case
	Case m.type='N'
		If Mod(xValue,1)=0
			m.type='I'
			Replace Type With 'I',Integer With xValue
		Else
			Replace Number With xValue
		Endif
	Case m.type='C'
		Replace Text With xValue
	Case m.type='L'
		Replace Logical With xValue
	Case m.type='D'
		Replace Date With xValue
	Case m.type='T'
		Replace Datetime With xValue
	Case m.type='Y'
		Replace Currency With xValue
	Other
		* none
	Endcase
	Replace Datetime With m.tDate
	
	Replace Timestamp With Datetime()
	Go Recno()
	Select (m.old)
Endif


*:********************************************************************
*:
*: Procedure : DateLocalGet
*:
*:********************************************************************
Procedure DateLocalGet( tDate, cVarName, xDefault, m.cUser )
If Used('CONFIG')
	Local m.old, m.CLSID, m.UserID
	m.old=Select()
	m.CLSID=Padr(cVarName,Fsize('CLSID','CONFIG'))
	
	If Not Empty(m.cUser) And Vartype(m.cUser)='C'
		m.UserID=m.cUser
	Else
		m.UserID=Padr(_UserID,Fsize('UserID','CONFIG'))
	Endif
	
	Select CONFIG
	Locate For Userid=m.UserID And CLSID=m.CLSID And Datetime=m.tDate
	If Found()
		Do Case
		Case Type='I'
			xDefault=Integer
		Case Type='N'
			xDefault=Mton(Number)
		Case Type='Y'
			xDefault=Currency
		Case Type='L'
			xDefault=Logical
		Case Type='D'
			xDefault=Date
		Case Type='T'
			xDefault=Datetime
		Case Type='C'
			xDefault=Alltrim(Text)
		Endcase
	Endif
	Select (m.old)
Endif
Return xDefault

*:********************************************************************
*:
*: Procedure : DateGlobalSet
*:
*:********************************************************************
Procedure DateGlobalSet(tDate, cVarName, vValue, cTypeForce)
Return DateLocalSet(tDate, cVarName, vValue, "",'**Global**')

*:********************************************************************
*:
*: Procedure : DateGlobalGet
*:
*:********************************************************************
Procedure DateGlobalGet( cVarName, xDefault )
Return DateLocalGet(tDate, cVarName, xDefault, '**Global**')

#include ActiveX.h

*:********************************************************************
*:
*: Procedure : RegActiveX
*:
*:********************************************************************
Procedure RegActiveX
* Register ActveX classes
* if just one class is not registred - fail
Local m.ret
m.ret=.T.
m.ret=m.ret And RegOCX(MsListView,"MSComctl.OCX",MsListKey,MsListData)
m.ret=m.ret And RegOCX(MsMail,"MSMapi32.OCX",MsMailKey,MsMailData)
Return m.ret

*:********************************************************************
*:
*: Procedure : RegOCX
*:
*:********************************************************************
Procedure RegOCX(cClassID, cOCXFile,cLicKey, cLicense)

Local fail, lNeedCopy, tmp1[1], tmp2[1], m.WinSys, m.WinSysOCX
fail=.F.

* ,    
If Not Empty(RegRead("HKCR\"+cClassID))
	*  
	*    
Else
	If Not File(cOCXFile)
		If Messagebox("   ActiveX  ("+cOCXFile+")"+Chr(13)+;
			"    ?",4+64,"")= 6

			cOCXfile=LocFile(xOCXFile,"OCX"," OCX")
			If Empty(cOCXfile)
				Return .F.
			EndIf
		Else
			Return .F.
		EndIf
	Endif
	
	*    system  windows
	* win2k  winxp -       
	
	m.lNeedCopy=.F.
	m.WinSys=Addbs(WindowsSystemDir())
	m.WinSysOCX=m.WinSys+Justfname(cOCXFile)
	
	
	If File(m.WinSysOCX)
		*   
		Agetfileversion(tmp1,m.WinSysOCX)
		Agetfileversion(tmp2,cOCXFile)
		If tmp1[11]<tmp2[11]
			m.lNeedCopy=.T.
		Endif
		
	Else
		m.lNeedCopy=.T.
	Endif
	If m.lNeedCopy
		Copy File (cOCXFile) To (m.WinSysOCX)
	Endif
	
	Declare Integer DllRegisterServer In (m.WinSysOCX)
	
	If DllRegisterServer() # 0
		fail=.T.
	Endif
	Clear Dlls "DllRegisterServer"
Endif

***  

If Empty(RegRead("HKCR\Licenses\"+cLicKey))
	If Not RegWrite("HKCR\Licenses\"+cLicKey,cLicense)
		fail=.T.
	Endif
Endif

If fail
	Messagebox("   ActiveX .",48,"")
Endif

Return Not fail

*:********************************************************************
*:
*: Procedure : GetDefault
*:
*:********************************************************************
Procedure GetDefault( m.cAlias, m.cField, m.xDefault )
* Get Default Setting for field m.cField of m.cAlias table
Return GetGlobalProfile('Default',Alltrim(m.cAlias)+'.'+Alltrim(m.cField), m.xDefault )

*:********************************************************************
*:
*: Procedure : Grant
*:
*:********************************************************************
Procedure Grant( m.popup, m.bar )
If Admin()
	Return .T.
Endif
If Not Used("grant")
	Return .F.
Endif
Select mask From Grant Where Object=chkval(Upper(m.popup)+Transform(m.bar,'@0')) And Group=chkval(_UserGroup) Into Array tmp
If _Tally=0
	Return .F.
Endif
Return Bittest(tmp[1],MASK_LIST)

*:********************************************************************
*:
*: Procedure : Profile
*:
*:********************************************************************
Procedure Profile(cSection,cEntry,xDefault,cIniFile)
cIniFile=Iif(Empty(cIniFile),_LOCALINI,cIniFile)

Local cValue, k, buf
cValue=XtoC(xDefault)

Declare Integer GetPrivateProfileString In Win32Api ;
	string Section,;
	string Entry,;
	string Default,;
	string @ Buffer,;
	integer bufferlen,;
	string iniFile

buf=Replicate(Chr(0),4096)

k=GetPrivateProfileString(cSection,cEntry,cValue,@buf,Len(buf),cIniFile)
If k > 0
	If Vartype(cValue)="N" And cValue=0
		Return Left(buf,k)
	Else
		Return CtoX(Left(buf,k),Vartype(xDefault))
	Endif
Else
	Return xDefault
Endif

*:********************************************************************
*:
*: Procedure : PutProfile
*:
*:********************************************************************
Procedure PutProfile(cSection,cEntry,xValue,cIniFile)
cIniFile=Iif(Empty(cIniFile),_LOCALINI,cIniFile)

Local cValue, k, buf
cValue=XtoC(xValue)

Declare Integer WritePrivateProfileString In Win32Api ;
	string Section,;
	string Entry,;
	string Value,;
	string iniFile

Return WritePrivateProfileString(cSection,cEntry,cValue,cIniFile) # 0

*:********************************************************************
*:
*: Procedure : ProfileSection
*:
*:********************************************************************
Procedure ProfileSection(aSections, cSection,cIniFile)
Local cIniValue, nTotEntries, nLastPos

cIniFile=Iif(Empty(cIniFile),_LOCALINI,cIniFile)
m.cIniValue=Profile(cSection,0,cNULL)

nTotEntries=Occurs(Chr(0),m.cIniValue)
Dimension aSections[m.nTotEntries]
nLastPos = 1
For i = 1 To m.nTotEntries
	nTmpPos = At(Chr(0),m.cIniValue,m.i)
	aSections[m.i] = Substr(m.cIniValue,m.nLastPos,m.nTmpPos-m.nLastPos)
	nLastPos = m.nTmpPos+1
Endfor
Return nTotEntries

*:********************************************************************
*:
*: Procedure : CtoX
*:
*:********************************************************************
Procedure CtoX
Lparameter m.cValue, m.cType
* Convert character value to cType type value ( as possible )
Do Case
Case m.cType='D'
	Return Ctod(m.cValue)
Case m.cType='T'
	Return Ctot(m.cValue)
Case m.cType='Y'
	Return Val(m.cValue)
Case m.cType='N'
	m.cValue=Val(m.cValue)
	Return Iif(Mod(m.cValue,1) # 0,m.cValue,Int(m.cValue))
Case m.cType='L'
	Return Inlist(Upper(m.cValue),'YES','ON','TRUE','1','.T.')
Endcase
Return m.cValue

*:********************************************************************
*:
*: Procedure : XtoC
*:
*:********************************************************************
Procedure XtoC
Lparameter cValue
* Convert any value to Character
Local m.cType, m.cRet
m.cType=Type('cValue')
m.cRet=""
Do Case
Case m.cType='D'
	m.cRet=Dtoc(cValue)
Case m.cType='T'
	m.cRet=Ttoc(cValue)
Case m.cType='N'
	m.cRet=Ltrim(Str(cValue,18,Iif(Mod(cValue,1)#0,2,0)))
Case m.cType='Y'
	m.cRet=Ltrim(Tran(cValue,'$$ 9999999999999999.9999'))
Case m.cType='L'
	m.cRet=Iif(cValue,'Yes','No')
Case m.cType='M'
	m.cRet=cValue
Case m.cType='C'
	If cValue=Chr(0)
		m.cRet=0
	Else
		m.cRet=cValue
	Endif
Other
	Return cValue
Endcase
Return (m.cRet)

*:********************************************************************
*:
*: Procedure : MainMenu
*:
*:********************************************************************
Procedure MainMenu(cName)
If cName='Quit'
	Do Shutdown In Main
Else
	If Vartype(ROOT_OBJECT)="O"
		With ROOT_OBJECT
			If Vartype(.Interface)="O"
				Local o
				o=Evaluate('.Interface.'+cName)
				o.Click()
			Endif
		Endwith
	Endif
Endif

*:********************************************************************
*:
*: Procedure : ActivateForm
*:
*:********************************************************************
Procedure ActivateForm(m.Obj,m.nState)
If Vartype(ROOT_OBJECT)='O'
	With ROOT_OBJECT
		If Vartype(.Interface)="O"
			With .Interface
				If Not Empty(m.nState) And Vartype(m.nState)="N"
					.State=m.nState
				Else
					.State=FACE_FREE
				Endif
				If Vartype(m.Obj)="O" And m.Obj.BaseClass="FORM"
					If PemStatus(m.Obj,"View",5)
						.State=Bitor(.State,FACE_VIEW)
					Endif
					If m.Obj.Class="Documentform"
						.State=Bitor(.State,FACE_DOCUMENT)
					Endif
					If Inlist(m.Obj.WindowType,1,3)
						.State=FACE_MODAL
						.Toolbar.Disable()
					Else
						.Toolbar.Enable()
					Endif
					If PemStatus(m.Obj,"FaceMask",5)
						.State=Bitor(.State,m.Obj.FaceMask)
					Endif
					.PadView.Enable=.T.
				Endif
				.SetState(.T.)
				If .State=FACE_MODAL
					If Popup("Reports")
						Set Skip Of Popup Reports .T.
					EndIf
				EndIf
			Endwith
		Endif
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : DeactivateForm
*:
*:********************************************************************
Procedure DeactivateForm(m.Obj)
If Vartype(ROOT_OBJECT)='O'
	With ROOT_OBJECT
		If Vartype(.Interface)="O"
			With .Interface
				.State=FACE_FREE
				.Toolbar.Disable()
				.SetState(.F.)
				.PadView.Enable=.F.
			Endwith
		Endif
		If Popup("Reports")
			Set Skip Of Popup Reports .F.
		EndIf
	Endwith
Endif

*:********************************************************************
*:
*: Procedure : DoObj
*:
*:********************************************************************
Procedure DoObj( cMethod )
If Type("_Screen.ActiveForm")="O"
	Local o, m.Obj
	o=_Screen.ActiveForm
	m.Obj=GetPem(o,"ParentObject")
	If Vartype(m.Obj) # "O"
		m.Obj=GetPem(m.Obj,"Parent")
	Endif
	If Vartype(m.Obj)="O"
		Return Evaluate("m.Obj."+cMethod)
	Endif
Endif
Return .F.

#define PASS_LEN	10

*:********************************************************************
*:
*: Procedure : Encrypt
*:
*:********************************************************************
Procedure Encrypt( m.Text)
Local s,e,x,i,r
m.Text=Padr(m.Text,PASS_LEN)
s=""
r=Val(Sys(2007,Sys(2015)))
Rand(r)
For i=1 to PASS_LEN
	s=s+Right(Transform(Bitxor(Asc(Substr(m.Text,i,1)),Int(Rand()*256)),'@0'),2)
Next
Return Lower(s+Right(Transform(r,'@0'),4))

*:********************************************************************
*:
*: Procedure : Decrypt
*:
*:********************************************************************
Procedure Decrypt(m.Text)
Local s,e,x,i,r
Rand(Val('0x'+Right(m.Text,4)))
m.Text=Padr(m.Text,PASS_LEN*2)
s=""
For i=1 To PASS_LEN
	s=s+Chr(Bitxor(Val('0x'+Substr(m.Text,(i-1)*2+1,2)),Int(Rand()*256)))
Next
Return Alltrim(s)

