*:********************************************************************
*:
*: Procedure file :main.prg
*:
*: (c) Piva, BEAR v.43 on 06.06.2003 13:37
*:********************************************************************
*
#include Include/Main.h

Lparameters  m.ParamStr

Close All
Clear All
Clear Program 
Clear Resources 

External File Bin\config.FPW

If Version(4)<"07.00.0000"	&& Version VFP 07.00 build 9465 (SP1)
	Messagebox("  FoxPro    VFP7.1 "+Version(4),16,VERSION_CAP)
	Return .F.
Endif

If FindInstance()
	Return .F.
EndIf

Local splash
*do form splash2 name splash linked

DO DelTemp
Do Set
Do Dlls

Set Proc To ;
	progs\common;
	,progs\config;
	,progs\App;
	,classes\Document;
	,classes\classes;
	,classes\tools;
	,classes\View;
	

Set Class To ;
	classes\basectrl;
	,classes\Document


Public _Aspect, _Aspect4View
_Aspect=1.0
_Aspect4View=.T.

****   
Public ;
	_Tables, _Reports, _Images, _PlugIns,_Title;
	,_FontName, _FontSize;
	,_Boot, _ReBoot, _UserID, _UserName, _UserGroup,_UserMachine;
	,_IsShutDown, _MutexHandle

_MutexHandle=0
_IsShutDown=.F.
_ReBoot=.F.			&& May be using hot restart &
_Tables='Tables'
_Reports='Reports'
_Images='Images'
_PlugIns='PlugIns'
_FontName='Tahoma'
_FontSize=8
_Assist=""
_Title=""

_UserID=Getwordnum(Sys(0),3)
_UserName=Getwordnum(Sys(0),3)
_UserGroup=0
_UserMachine=Getwordnum(Sys(0),1)

***   (may be using TYPEDEF ?)
Public ;
	_Pic_Price,	_Pic_Amount,	_Pic_Count;
	,_Pic_Summa, 	_Pic_Total,		_Pic_Percent;
	,_Pic_Bucks, 	_Pic_Number;
	,_Tax_Round,	_Round


_Pic_Price='999 999.99'
_Pic_Amount='999 999 999'
_Pic_Count='999 999 999'
_Pic_Summa='999 999 999.99'
_Pic_Total=_Pic_Summa
_Pic_Percent='999.9%'
_Pic_Bucks='999 999.999'
_Pic_Number='999999999'
_Tax_Round=2
_Round=2

***    (TYPEDEF such as _RunTime.Quit, Boot, or Bit1, Bit2 as so on )
Public _LocalIni
_LocalIni=Full('Config.INI')

If Not RegActiveX()
	Return .F.
Endif

HideAllToolBars()

*!*	If Wexist("Command")
*!*		Release Windows Command
*!*	Endif

Do While .T.
	
	If Txnlevel() > 0
		* Have uncommited transaction ?
		* We must RollBack or try to Commit Changes
		Local k,i
		Store 0 To i,k
		Notify('   ...')
		Do While Txnlevel() > 0
			i=i+1
			k=Txnlevel()
			RollBack_Transaction()
			If Txnlevel()=k
				* unable to ROLLING !!! back transaction
				Messagebox("  .",16,"")
				Return .F.
			Endif
			If i > 5
				*    
				Messagebox("  .   .",16,"")
				Return .F.
			Endif
		Enddo
		Notify()
	Endif
	
	_ReBoot=.F.
	
	Public ROOT_OBJECT
	ROOT_OBJECT=Newobject("kernel","classes\kernel.prg")
	If Vartype(ROOT_OBJECT)='O'
		With ROOT_OBJECT
			.Newobject("SETUP","SETUP","SETUP.PRG")
			If Vartype(.Setup)='O'
				Do Storage		&& 
				
				Do Order		&&  
				Do Payment		&&  
				Do Customer		&& 
				
				Do Supply		&& 
				Do Invoice		&& 
				
				Do Face			&& 
				
				Do Reports		&& 
				
				With .Reports
					.MakeMenu()
				Endwith
				
			Endif
			
			*** StartUp Options
			
			_Screen.Visible=.T.
			_Screen.WindowState=2
			
			Release splash
			
			On Shutdown Do Shutdown In Main
			
			If Not _IsShutDown
				.StartUp()
			Endif
			
		Endwith
		
		Release splash
		
		If Not _IsShutDown
			If GetLocalProfile("Boot","DebugPad",.F.)
				On Key Label Alt+F11 Do AddDebug
			Endif
			If GetLocalProfile("Boot","ErrorTrap",.T.)
				On Error Do ERRHAND In Main With Error(),Program(),Lineno()
			Endif
			DeactivateForm()
			Read Events
		Endif
	Endif
	
	If Vartype(_ReBoot)='L' And _ReBoot
		Loop
	Else
		Exit
	Endif
Enddo

*:********************************************************************
*:
*: Procedure : CLEANUP
*:
*:********************************************************************
Procedure CLEANUP
Local o
For Each o In _Screen.Forms
	o.Release
Next
Pop Menu _Msysmenu To Master
Clear Popups All
Clear Events

*:********************************************************************
*:
*: Procedure : Shutdown
*:
*:********************************************************************
Procedure Shutdown(lNoAsk)
If Not lNoAsk And GetLocalProfile("Boot","ExitConfirm",.T.)
	If Messagebox(MSG_SHUTDOWN,4+32,_Screen.Caption) # 6
		Return .F.
	Endif
Endif

Local m.quit, m.info
m.quit=GetLocalProfile("Boot","Quit",.T.)
m.info=Info("   ...")

Release ROOT_OBJECT

Clear Events

On Shutdown
Do CLEANUP
Close All

If m.quit
	Quit
Endif
On Error

*:********************************************************************
*:
*: Procedure : ERRHAND
*:
*:********************************************************************
Proc ERRHAND (m.nError, m.cMethod, m.nLine)
Do Logerror With m.nError, m.cMethod, m.nLine
Local k
k=Messagebox(;
	"  "+Ltrim(Str(nError))+Chr(13)+;
	Message()+Chr(13)+;
	m.cMethod+Chr(13)+;
	Ltrim(Str(nLine));
	,2+48+512,'')
Do Case
Case k=3
	Cancel
Case k=4
	Retry
Case k=5
	Return
Endcase


*:********************************************************************
*:
*: Procedure : FindInstance
*:
*:********************************************************************
Procedure FindInstance
If _Vfp.StartMode=0
	Return .F.
EndIf

*
*   ,        
*
#define GWL_USERDATA			(-21)
#define ERROR_ALREADY_EXISTS    183

Declare Integer CreateMutex 		in Win32Api integer, integer, string 
Declare Integer ReleaseMutex 		in Win32Api integer
Declare Integer CloseHandle 		in Win32Api integer

Declare Long 	GetWindowLong 		in Win32Api integer, integer
Declare Long 	SetWindowLong 		in Win32Api integer, integer, long
Declare Integer GetLastError 		in Win32Api

Declare Integer GetTopWindow 		in Win32Api integer
Declare Integer GetWindow 			in Win32Api integer, integer
Declare Integer SetForegroundWindow in Win32Api integer
Declare Integer ShowWindow in Win32Api integer, integer

Local m.Mutex, m.Magic, hMutex, hwnd, m.ret

m.ret=.F.					&&  
m.Mutex="My.Mutex.0001"		&&  
m.Magic=0x12345678			&&   (   !)

hMutex=CreateMutex(0,0,m.Mutex)
*  Mutex  
If GetLastError()=ERROR_ALREADY_EXISTS
	CloseHandle(hMutex)				&&  
	
	hwnd=GetTopWindow(0)			&&  
	DO While hwnd # 0
		hwnd=GetWindow(hwnd,2)		&&  
		If hwnd # 0					&&  hWnd
			If GetWindowLong(hwnd,GWL_USERDATA)=m.Magic  &&      
				*      
				*      ""
				SetForegroundWindow(hwnd)	&&     
				ShowWindow(hwnd,3)			&&   
				m.Ret=.T.
				Exit
			EndIf 
		EndIf
	EndDo
	
Else
	SetWindowLong(_vfp.hwnd,GWL_USERDATA,m.Magic)	&&     
	ReleaseMutex(hMutex)			&& Mutex     -     
EndIf
Return m.Ret

*:********************************************************************
*:
*: Procedure : Dummy
*:
*:********************************************************************
Procedure Dummy
Do External

*: End of main.prg
