*:********************************************************************
*:
*: Procedure file :query.prg
*:
*: Contents :
*: 
*: 		Class     My AS QueryForm
*: 
*: 		Class     QueryForm AS DialogForm
*: 
*: 		Class     QueryBlock AS Container
*: 
*: 		Class     QueryOwnerBlock AS Container
*: 
*: 		Class     DateQueryBlock AS Container
*:
*: (c) Piva, BEAR v.43 on 25.04.2003 16:15
*:********************************************************************
#include main.h

Return CreateObject("QueryForm")

*:********************************************************************
*:
*:    Class : QueryForm based on DialogForm
*:
*:********************************************************************
Define Class QueryForm AS DialogForm
	Caption=' '
	DateMin={}
	DateMax={}
	OwnerID=""
	CustID=""
	GroupID=""
	ItemID=""
	DeskTop=.F.
	
	Add Object Image as MyImage with ;
		Top=15,;
		Left=15,;
		Picture=BMP_QUERY
	
	Add Object Text as MyLabel with ;
		Top=15,;
		Left=60,;
		Width=375-60-10,;
		Height=46,;
		Caption="  "
	
	Add Object Shape as MyShape with ;
		Top=60,;
		Left=10
	
	Add Object Owner 	as QueryOwnerBlock with ChkData.Caption=""
	
	Add Object Customer as QueryCustBlock with ChkData.Caption=''
	
	Add Object Group 	as QueryGroupBlock with ChkData.Caption=''
	
	Add Object Item 	as QueryItemBlock with ChkData.Caption=''
	
	Add Object Dates 	as DateQueryBlock
	
	cmdOk.Default=.T.
	
	*:********************************************************************
	*:
	*: Method : Init of class QueryForm
	*:
	*:********************************************************************
	Procedure Init
	With this
		If Not DoDefault()
			Return .F.
		EndIf
		If not .Hook()
			Return .F.
		EndIf
	EndWith

	Procedure Show(nType)
	With this
		.LoadParameters()
		.Arrange()
		Aspect(this)
		DoDefault(nType)
	EndWith

	
	*:********************************************************************
	*:
	*: Method : Hook of class QueryForm
	*:
	*:********************************************************************
	Procedure Hook	&& Export Event
	
	*:********************************************************************
	*:
	*: Method : Arrange of class QueryForm
	*:
	*:********************************************************************
	Procedure Arrange
	* Arrange QueryBlocks Method
	With this
		Local m.top,m.index
		m.top=70
		m.index=0
		For each o in .Controls
			If o.baseclass='Container'
				If o.Name='Container'
					Loop
				EndIf
				If o.Visible
					m.Index = m.Index + 1 
					o.TabIndex=m.Index
					o.Top=m.Top
					m.Top=o.Top+o.Height+10
				EndIf
			EndIf
		Next
	EndWith

	Procedure LoadParameters
	With this
		.Owner.Value=.OwnerID
		.Customer.Value=.CustID
		.Group.Value=.GroupID
		.Item.Value=.ItemID
		.Dates.DateMin.Value=.DateMin
		.Dates.DateMax.Value=.DateMax
	EndWith
	
EndDefine


Define Class QueryCustBlock as QueryBlock
	Alias="CUSTOMER"
	Field="NAME"
	Key="CUSTID"

	Procedure cmdLook.Click
	With this.parent
		Private m.CustID,m.Name
		m.CustID=.Value
		m.Name=.Text.Value

		DO GetCust with m.CustID,m.Name

		.Value=m.CustID
		.Text.Value=m.Name

	EndWith
	
EndDefine
	

Define Class QueryGroupBlock as QueryBlock
	Alias="PART"
	Field="NAME"
	Key="GROUPID"


	Procedure cmdLook.Click
	With this.parent
		.Value=GetGroup(.Value)
	EndWith
	
EndDefine


Define Class QueryItemBlock as QueryBlock
	Alias="ITEM"
	Field="NAME"
	Key="ITEMID"
	

	Procedure cmdLook.Click
	With this.parent
		.Value=GetItem(.Value,.parent.group.value)
	EndWith

	
EndDefine


*:********************************************************************
*:
*:    Class : QueryBlock based on Container
*:
*:********************************************************************
Define Class QueryBlock as Container
	BorderWidth=0
	BackStyle=0
	Height=22
	Width=355
	Value=""
	Alias=""
	
	
	Add Object chkData as MyCheck with ;
		Top=4,;
		Left=15,;
		StatusBarText="      "
	
	Add Object Text as MyText with ;
		Top=0,;
		Left=100,;
		Width=375-20-100-24,;
		Height=22,;
		Style=2,;
		ReadOnly=.T.,;
		StatusBarText="   "
	
	Add Object cmdLook as cmdLook with ;
		Top=0,;
		Left=375-20-22
	
	
	*:********************************************************************
	*:
	*: Method : Init of class QueryBlock
	*:
	*:********************************************************************
	Procedure Init
	This.chkData.Click
	
	*:********************************************************************
	*:
	*: Method : ChkData.Click of class QueryBlock
	*:
	*:********************************************************************
	Procedure ChkData.Click
	With this
		.parent.cmdLook.Enabled=.Value
		If Empty(.Value)
			.Parent.Value=C_MIN_UNIQUEID
		EndIf
	EndWith
	

	*:********************************************************************
	*:
	*: Method : ChkData.Click of class QueryBlock
	*:
	*:********************************************************************
	Procedure ChkData.InteractiveChange
	With this
		If not Empty(.Value)
			.Parent.cmdLook.Click
		EndIf
	EndWith


	*:********************************************************************
	*:
	*: Method : ChkData.Value_Assign of class QueryBlock
	*:
	*:********************************************************************
	Procedure ChkData.Value_Assign(xVal)
	With this
		.Value=xVal
		.Click()
	EndWith


	Procedure Value_Assign(m.Val)
	With this
		If .Visible
			.Value=m.Val
			Local tmp[1], m.field, m.key
			m.field=.Field
			m.key=.Key
			Select &Field from (.Alias) where &key=m.Val into array TMP
			.Text.Value=Iif(_TALLY=0,"",Alltrim(TMP[1]))
			.chkData.Value=not Empty(.Value)
			.cmdLook.Enabled=not Empty(.Value)
		EndIf
	EndWith

	Procedure Value_Access
	With this
		Return Iif(.Visible and .ChkData.Value,.Value,C_MIN_UNIQUEID)
	EndWith
	
EndDefine


*:********************************************************************
*:
*:    Class : QueryOwnerBlock based on Container
*:
*:********************************************************************
Define Class QueryOwnerBlock as Container
	BorderWidth=0
	BackStyle=0
	Height=22
	Width=355
	Value=""
	
	Add Object chkData as MyCheck with ;
		Top=4,;
		Left=15,;
		Value=.F.,;
		StatusBarText="     "
	
	Add Object cboOwner as cboOwner with ;
		Top=0,;
		Left=100,;
		Width=375-20-100
	
	
	*:********************************************************************
	*:
	*: Method : Init of class QueryOwnerBlock
	*:
	*:********************************************************************
	Procedure Init
	With this
		.chkData.Click
		.cboOwner.Requery
		.cboOwner.ListIndex=1
	EndWith
	
	*:********************************************************************
	*:
	*: Method : ChkData.Click of class QueryOwnerBlock
	*:
	*:********************************************************************
	Procedure ChkData.Click
	With this.Parent 
		.cboOwner.Enabled=this.Value
	EndWith
	
	Procedure Value_Assign(m.Val)
	With this
		.chkData.Value=not Empty(m.Val)
		.cboOwner.Enabled=not Empty(m.Val)
		.CboOwner.Value=Iif(Empty(m.Val),.CboOwner.Value,m.Val)

	EndWith

	Procedure Value_Access
	With this
		Return Iif(.Visible and .ChkData.Value,.CboOwner.Value,C_MIN_UNIQUEID)
	EndWith

	Procedure CboOwner.Valid
	This.Parent.Value=This.Value
	
EndDefine


*:********************************************************************
*:
*:    Class : DateQueryBlock based on Container
*:
*:********************************************************************
Define Class DateQueryBlock as Container
	BorderWidth=0
	BackStyle=0
	Height=22
	Width=355
	
	Add Object lblFrom as MyLabel with ;
		Top=4,;
		Left=15,;
		Caption='  ',;
		Alignment=1
	
	Add Object DateMin as MyText with ;
		Top=2,;
		Left=100,;
		Width=80,;
		Value={},;
		StatusBarText="   "
	
	Add Object lblTo as MyLabel with ;
		Top=4,;
		Left=190,;
		Caption='',;
		AutoSize=.T.
	
	Add Object DateMax as MyText with ;
		Top=2,;
		Left=210,;
		Width=80,;
		Value={},;
		StatusBarText="   "
	
EndDefine
*: End of query.prg
